{$I-}
Program DosMenus;

{ (c) Pierre UNGERER 1989,1991,1992,1993

  This program creates menus directly usable by MS/Dos using the ERRORLEVEL
       exit code                                                            }

{$I MENU001.ITP}
{$I MENU002.ITP}
{$I MENU003.ITP}
{$I MENU004.ITP}

Begin { PROGRAM }

   InitScreenType;
   GetIfAMouse;

   New (SavedScreen [0]);
   SavedScreen [0]^ := TheScreen^;
   CurrentScreen :=  1;
   MouseStepX    :=  8;
   MouseStepY    :=  8;
   MouseLines    := 25;
   MouseL        :=160;
   XS            := WhereX;
   YS            := WhereY;
   OffsetX       :=  0;
   OffsetY       :=  0;
   WhoAmI        := ParamStr (0);
   If WhoAmI = ''
   Then WhoAmI   := 'MENU'
   Else WhoAmI   := ExeName (WhoAmI);

   If ParamCount = 0 Then Begin Usage; Halt (0) End;

   New (SavedScreen [CurrentScreen]);
   SavedScreen [CurrentScreen]^ := TheScreen^;
   Inc (CurrentScreen);

   Color [2] := TextAttr Shr $4;
   Color [1] := TextAttr And $F;
   Color [3] := Color [2];
   Color [4] := Color [1];
   Color [5] := Color [2];
   Color [6] := Color [1];
   Color [7] := Color [1];
   Color [8] := Color [2];
   Color [9] := Color [2];
   Color[10] := Color [1];
   Color[11] := Color [2];
   Color[12] := Color [1];
   Color[13] := Color [1];
   Color[14] := Color [2];

   Numbers     := False;
   IsExit      := False;
   ToExecute   := False;
   SaveScreen  := False;
   IsAFile     := False;
   IsHelp      := False;
   IsLangFile  := False;
   NoEntry     := False;
   EscapeOut   := False;
   EscMouse    := False;
   FirstTime   := True;
   Horizontal  := True;
   Vertical    := True;
   For FOpt    := 0 To 9
   Do Begin
        ConstBefore [FOpt] := '';
        ConstAfter  [FOpt] := '';
      End;
   For FOpt    := 1 To MaxFuncKeys
   Do Begin
        FuncKeyStr [FOpt]      :=  '';
        ToolBox    [FOpt].X    := 0;
        ToolBox    [FOpt].Y    := 0;
        ToolBox    [FOpt].Text := '';
      End;

   Automatic      := '';
   AutomaticUp    := '';
   AutomaticDown  := '';
   AutomaticRight := '';
   AutomaticLeft  := '';

   FirstChoice  := Nil;
   MaxChoice    := 1;
   MinJustify   := 1;
   FOpt         := 1;
   FOptI        := 0;
   CurPage      := '1';
   EscapeX      := 0;
   EscapeY      := 0;
   EscapeXF     := 0;
   EscapeYF     := 0;
   TheDelay     := 0;
   ToQuit       := 0;
   MaxJustify   := 0;
   EnvVarsFile  := '_M.BAT';
   DefVarsFile  := '_MV.BAT';
   ExecuteFile  := '_MX.BAT';
   WriteLn (OutPut);

   If (Copy (ParamStr (1), 1, 1) = '?') And (ParamCount = 1)
   Then Begin Help; IsHelp := True; End
   Else If     (Copy (ParamStr (1), 1, 1) <> '-')
           And (Copy (ParamStr (1), 1, 1) <> '+')
           And (Copy (ParamStr (1), 1, 1) <> '"')
           And (Copy (ParamStr (1), 1, 1) <> '''')
        Then IsAFile := InitText (ParamStr (1), False, MenuDesc)
        Else InitParam (ParamStr (1));
   { End If }

   If ParamCount > 1 Then For I := 2 To ParamCount Do InitParam (ParamStr (I));

   If IsAFile And Not IsHelp Then InitParamF;

   If IsExit And Not ToExecute
      Then XitCode := 0
      Else XitCode := DoMenu;

   If SaveScreen And (CurrentScreen <= 2) And (CurrentScreen > 0)
      Then Begin
         Dec (CurrentScreen);
         TheScreen^ := SavedScreen [CurrentScreen]^;
         Dispose (SavedScreen [CurrentScreen]);
         GetMouseBackAttr;
           End; { If }

   GotoXY (XS, YS);
   If IsAMouse Then SetMouseBackAttr;

   Halt (XitCode);

End. { Main DosMenu }
