Procedure DSCDEBUT

Parameter T2P

SET CURSOR     OFF
SET BELL       OFF
SET SAFETY     OFF
SET TALK       OFF
SET HEADING    OFF
SET SCOREBOARD ON
SET DELETE     ON
SET DATE       FRENCH

SET KEY        28     TO HELP
*SETCANCEL    (.F.)

HelpKey="PASSE"

if file("HELPDSC.DBF") .and. file("HELPDSC.DBT") .and. file("HELPDSC.NTX")
   HelpName="HELPDSC"
else
   HelpName="\"+CurDir()+"\HELPDSC"
endif

Colored=.not. ("M" $ T2P) .and. IsColor()
FondP=replicate(chr(iif(Colored,177,176)),9)
if "1" $ T2P
   FondP=replicate(chr(176),9)
endif
if "2" $ T2P
   FondP=replicate(chr(177),9)
endif
if "3" $ T2P
   FondP=replicate(chr(178),9)
endif
if "4" $ T2P
   FondP=replicate(chr(219),9)
endif
if "5" $ T2P
   FondP=replicate(chr(32),9)
endif
if "6" $ T2P
   FondP=replicate(chr(249),9)
endif
if "7" $ T2P
   FondP=replicate(chr(250),9)
endif
if "8" $ T2P
   FondP=replicate(chr(254),9)
endif
IsToned=(("S" $ T2P) .and. .not. ("NS" $ T2P))
IsHour=(("H" $ T2P) .and. .not. ("NH" $ T2P))

do COLORE with Colored

CurScr=1
CurPtSc=0
IsHelp=.F.
l0=1
q0=space(8)
fin=chr(27)
MaxLigImp=60

FANA1=0
FANA2=99
FANS1=0
FANS2=99
PLAGE=space(29)
l200000=1
l300000=1
LMOUSE=1

do SAVSCR

do DSCPRES

SET KEY       -39     TO ALTF10
SET KEY       -29     TO CTRLF10
SET KEY       -19     TO SHF10
SET KEY       -28     TO CTRLF9
SET KEY       -9      TO F10
SET KEY       -8      TO F9
SET KEY       -18     TO SHF9
SET KEY       -1      TO F2
SET KEY       -11     TO SHF2
SET KEY       -3      TO F4
SET KEY       -23     TO CTRLF4
SET KEY       -38     TO ALTF9
SET KEY       -33     TO MOUSE

If .not. file("GROUPES.DBF") .or. .not. file("GROUPES.DBT")
   do SAVSCR
   do BACPAT with "Cration du fichier des auteurss",10
   do CGROUPES
   do RSTSCR
endif

if .not. file("GROUPE.NTX")
   do SAVSCR
   do BACPAT with "Cration du premier index sur les auteurs",10
   use GROUPES
   index on GROUPES->GROUPE to GROUPE
   use
   do RSTSCR
endif

if .not. file("NOGRP.NTX")
   do SAVSCR
   do BACPAT with "Cration du deuxime index sur les auteurs",10
   use GROUPES
   index on GROUPES->NOGRP to NOGRP
   use
   do RSTSCR
endif

If .not. file("DISQUES.DBF") .or. .not. file ("DISQUES.DBT")
   do SAVSCR
   do BACPAT with "Cration du fichier des disques",10
   do CDISQUES
   do RSTSCR
endif

if .not. file("DISQUE.NTX")
   do SAVSCR
   do BACPAT with "Cration du premier index sur les disques",10
   use DISQUES
   index on DISQUES->DISQUE to DISQUE
   use
   do RSTSCR
endif

if .not. file("ORDSC.NTX")
   do SAVSCR
   do BACPAT with "Cration du deuxime index sur les disques",10
   use DISQUES
   index on str(DISQUES->NOGROUP,3)+str(DISQUES->ANSORTIE,2)+ ;
            str(DISQUES->ANACHAT,2)+DISQUE to ORDSC
   use
   do RSTSCR
endif

if .not. file("NODSC.NTX")
   do SAVSCR
   do BACPAT with "Cration du troisime index sur les disques",10
   use DISQUES
   index on str(DISQUES->NOGROUP,3)+str(DISQUES->NODSC,3) to NODSC
   use
   do RSTSCR
endif

If .not. file("TITRES.DBF") .or. .not. file("TITRES.DBT")
   do SAVSCR
   do BACPAT with "Cration du fichier des titres",10
   do CTITRES
   do RSTSCR
endif

If .not. file("ORTIT.NTX")
   do SAVSCR
   do BACPAT with "Cration du premier index sur les titres",10
   use TITRES
   index on str(TGP,3)+str(TDS,3)+str(OT,2) to ORTIT
   do RSTSCR
endif

If .not. file("TITRE.NTX")
   do SAVSCR
   do BACPAT with "Cration du deuxime index sur les titres",10
   use TITRES
   index on TITRE to TITRE
   do RSTSCR
endif

If .not. file("GENRES.DBF")
   do SAVSCR
   do BACPAT with "Cration du fichier des genres",10
   do CGENRES
   do RSTSCR
endif

if .not. file("GENRE.NTX")
   do SAVSCR
   do BACPAT with "Cration du premier index sur les genres",10
   use GENRES
   index on GENRES->GENRE to GENRE
   use
   do RSTSCR
endif

if .not. file("GCLAIR.NTX")
   do SAVSCR
   do BACPAT with "Cration du deuxime index sur les genres",10
   use GENRES
   index on left(GENRES->GCLAIR,4) to GCLAIR
   use
   do RSTSCR
endif

If .not. file("TYPES.DBF")
   do SAVSCR
   do BACPAT with "Cration du fichier des types",10
   do CTYPES
   do RSTSCR
endif

if .not. file("TVISIT.NTX")
   do SAVSCR
   do BACPAT with "Cration du premier index sur les types",10
   use TYPES
   index on TYPES->TVISIT to TVISIT
   use
   do RSTSCR
endif

if .not. file("TYPE.NTX")
   do SAVSCR
   do BACPAT with "Cration du deuxime index sur les types",10
   use TYPES
   index on TYPES->TYPE to TYPE
   use
   do RSTSCR
endif

If .not. file("L_GR.DBF")
   do SAVSCR
   do BACPAT with "Cration du filtre des genres",10
   do CFGR
   do RSTSCR
endif

if .not. file("I_GR.NTX")
   do SAVSCR
   do BACPAT with "Cration de l'index filtre des genres",10
   use L_GR
   index on L_GR->GR to I_GR
   use
   do RSTSCR
endif

If .not. file("L_GP.DBF")
   do SAVSCR
   do BACPAT with "Cration du filtre des groupes",10
   do CFGP
   do RSTSCR
endif

if .not. file("I_GP.NTX")
   do SAVSCR
   do BACPAT with "Cration de l'index filtre des groupes",10
   use L_GP
   index on L_GP->GP to I_GP
   use
   do RSTSCR
endif

If .not. file("L_TY.DBF")
   do SAVSCR
   do BACPAT with "Cration du filtre des types",10
   do CFTY
   do RSTSCR
endif

if .not. file("I_TY.NTX")
   do SAVSCR
   do BACPAT with "Cration de l'index filtre des types",10
   use L_TY
   index on L_TY->TY to I_TY
   use
   do RSTSCR
endif

return

Procedure DSCFIN

do RSTSCR
SET CURSOR ON
set color to &CRIEN
Ligne=Ligne+1
@24,0 say ""
do while ligne>17
   ?
   Ligne=Ligne-1
enddo
@Ligne,0
if iscolor()
   set color to N/R
else
   set color to N/W
endif
@Ligne,0,Ligne+4,25 box "******** "
@Ligne+2,4 say "C.P.U. Vous salue."
set color to &CRIEN
@Ligne+5,0

return

Procedure CGROUPES

Create TEMP
use TEMP
append blank
replace Field_Name with "GROUPE",Field_type with "C",Field_Len with 40 ;
        Field_Dec with 0
append blank
replace Field_Name with "NOGRP",Field_type with "N",Field_Len with 3 ;
        Field_Dec with 0
append blank
replace Field_Name with "GENRE",Field_type with "N",Field_Len with 3 ;
        Field_Dec with 0
append blank
replace Field_Name with "MEMOG",Field_type with "M",Field_Len with 10 ;
        Field_Dec with 0
use
Create GROUPES From TEMP
use GROUPES
append blank
replace GROUPE with "GROUP <A NEW>",NOGRP with 1,GENRE with 1
use
delete file (CurDir+"TEMP.DBF")
delete file (CurDir+"GROUPE.NTX")
delete file (CurDir+"NOGRP.NTX")

return

*****************************************************************************

Procedure CDISQUES

Create TEMP
use TEMP
append blank
replace Field_Name with "DISQUE",Field_type with "C",Field_Len with 40 ;
        Field_Dec with 0
append blank
replace Field_Name with "ANSORTIE",Field_type with "N",Field_Len with 4 ;
        Field_Dec with 0
append blank
replace Field_Name with "ANACHAT",Field_type with "N",Field_Len with 4 ;
        Field_Dec with 0
append blank
replace Field_Name with "TYPE",Field_type with "N",Field_Len with 2 ;
        Field_Dec with 0
append blank
replace Field_Name with "PRETE",Field_type with "L",Field_Len with 1 ;
        Field_Dec with 0
append blank
replace Field_Name with "NOGROUP",Field_type with "N",Field_Len with 3 ;
        Field_Dec with 0
append blank
replace Field_Name with "NODSC",Field_type with "N",Field_Len with 3 ;
        Field_Dec with 0
append blank
replace Field_Name with "MEMO",Field_type with "M",Field_Len with 10 ;
        Field_Dec with 0
use
Create DISQUES From TEMP
delete file (CurDir+"TEMP.DBF")
delete file (CurDir+"DISQUE.NTX")
delete file (CurDir+"ORDSC.NTX")

return


*****************************************************************************

Procedure CTITRES

Create TEMP
use TEMP
append blank
replace Field_Name with "TGP",Field_type with "N",Field_Len with 3 ;
        Field_Dec with 0
append blank
replace Field_Name with "TDS",Field_type with "N",Field_Len with 3 ;
        Field_Dec with 0
append blank
replace Field_Name with "OT",Field_type with "N",Field_Len with 2 ;
        Field_Dec with 0
append blank
replace Field_Name with "DURE",Field_type with "C",Field_Len with 5 ;
        Field_Dec with 0
append blank
replace Field_Name with "TITRE",Field_type with "C",Field_Len with 40 ;
        Field_Dec with 0
append blank
replace Field_Name with "MEMOT",Field_type with "M",Field_Len with 10 ;
        Field_Dec with 0
use
Create TITRES From TEMP
delete file (CurDir+"TEMP.DBF")
delete file (CurDir+"TITRE.NTX")
delete file (CurDir+"ORTIT.NTX")

return

*****************************************************************************

Procedure CGENRES

Create TEMP
use TEMP
append blank
replace Field_Name with "GENRE",Field_type with "N",Field_Len with 2 ;
        Field_Dec with 0
append blank
replace Field_Name with "GCLAIR",Field_type with "C",Field_Len with 20 ;
        Field_Dec with 0
use
Create GENRES From TEMP
use GENRES
append blank
replace GENRE with 1,GCLAIR with "VARIETES"
use
delete file (CurDir+"TEMP.DBF")
delete file (CurDir+"GCLAIR.NTX")
delete file (CurDir+"GENRE.NTX")

return

*****************************************************************************

Procedure CTYPES

Create TEMP
use TEMP
append blank
replace Field_Name with "TYPE",Field_type with "N",Field_Len with 2 ;
        Field_Dec with 0
append blank
replace Field_Name with "TCLAIR",Field_type with "C",Field_Len with 20 ;
        Field_Dec with 0
append blank
replace Field_Name with "TVISIT",Field_type with "C",Field_Len with 4 ;
        Field_Dec with 0
use
Create TYPES From TEMP
use TYPES
append blank
replace TYPE with 1,TCLAIR with "LP",TVISIT with "LP"
use
delete file (CurDir+"TEMP.DBF")
delete file (CurDir+"TYPE.NTX")
delete file (CurDir+"TVISIT.NTX")

return

*****************************************************************************

Procedure CFGR

Create TEMP
use TEMP
append blank
replace Field_Name with "GR",Field_type with "N",Field_Len with 2 ;
        Field_Dec with 0
use
Create L_GR From TEMP
delete file (CurDir+"TEMP.DBF")
delete file (CurDir+"I_GR.NTX")

return

*****************************************************************************

Procedure CFGP

Create TEMP
use TEMP
append blank
replace Field_Name with "GP",Field_type with "N",Field_Len with 3 ;
        Field_Dec with 0
use
Create L_GP From TEMP
delete file (CurDir+"TEMP.DBF")
delete file (CurDir+"I_GP.NTX")

return

*****************************************************************************

Procedure CFTY

Create TEMP
use TEMP
append blank
replace Field_Name with "TY",Field_type with "N",Field_Len with 2 ;
        Field_Dec with 0
append blank
replace Field_Name with "VAL",Field_type with "N",Field_Len with 2 ;
        Field_Dec with 0
use
Create L_TY From TEMP
delete file (CurDir+"TEMP.DBF")
delete file (CurDir+"I_TY.NTX")

return

****************************************************************************

procedure DSCPRES

set color to &BSW
clear
TEXT





Ŀ
        ͻ        
            ۱ ۱ ۱ ۱ ۱ ۱ ۱          
          ۱ ۱   ۱   ۱     ۱ ۱ ۱ ۱ ۱     ۱              
          ۱ ۱   ۱   ۱ ۱ ۱ ۱ ۱ ۱   ۱          
          ۱ ۱   ۱       ۱ ۱ ۱  ۱ ۱ ۱         ۱          
            ۱ ۱ ۱ ۱ ۱ ۱          
                                                                           
        ͼ        

                                                        (c) P. U. 1989
ENDTEXT

set color to &CRIEN
@0,0
@1,0 to 1,79
@23,0 to 23,79
@24,0

return

****************************************************************************

procedure Reorganize

do SAVSCR
do BACPAT with "Remembrement en cours ...",10

select 1
Use GROUPES index NOGRP
copy to X
Use X
select 2
Use DISQUES
select 3
Use TITRES
select 1

Set Color To
@ 15,10 clear to 19,69
@ 15,10 to 19,69
@ 16,12 say "Auteurs :"
@ 17,12 say "Disques :"
@ 18,12 say "Titres  :"
go top
NGP=1

do while .not. eof()

   @ 15,32 say "   "+str(recno(),5)+"/"+str(reccount(),5)+"    "
   Set Color To /W+
   @ 16,22,16,int(45*recno()/reccount())+22 box ""
   Set Color To

   if X->NOGRP <> NGP
      select 3
      Replace all TITRES->TGP with NGP for TITRES->TGP=X->NOGRP
      select 2
      Replace all DISQUES->NOGROUP with NGP for DISQUES->NOGROUP=X->NOGRP
      select 1
      Replace NOGRP with NGP
   endif

   NGP=NGP+1
   skip

enddo

copy to GROUPES
Use GROUPES
@15,32 say " Rindexe AUTEURS "
set index to GROUPE,NOGRP
Reindex
Use
delete file (CurDir+"X.*")

select 2
set index to ORDSC
copy to Y
Use Y
go top
@15,11 To 15,68

NGP=Y->NOGROUP

do while .not. eof()

   NDS=1

   do while NGP=Y->NOGROUP .and. .not. eof()

      @ 15,32 say str(recno(),5)+"/"+str(reccount(),5)+" "
      Set Color To /W+
      @ 17,22,17,int(45*recno()/reccount())+22 box ""
      Set Color To

      if Y->NODSC <> NDS

         x=recno()
         replace all Y->NODSC with -NDS for Y->NODSC=NDS .and. Y->NOGROUP=NGP
         go x
         select 3
         replace all TITRES->TDS with -NDS for TITRES->TDS=NDS .and. ;
                     TITRES->TGP=NGP
         replace all TITRES->TDS with NDS for TITRES->TDS=Y->NODSC .and. ;
                     TITRES->TGP=NGP
         select 2
         replace Y->NODSC with NDS

      endif

      skip
      NDS=NDS+1

   enddo

   NGP=Y->NOGROUP

enddo

copy to DISQUES
Use DISQUES
@15,32 say " Rindexe DISQUES "
set index to DISQUE,ORDSC
Reindex
Use
delete file (CurDir+"Y.*")

select 3
set index to ORDSC
copy to Z
Use Z
go top
@15,11 To 15,68

NGP=Z->TGP

do while .not. eof()

   NDS=Z->TDS

   do while Z->TGP=NGP .and. .not. eof()

      NTI=1

      do while Z->TGP=NGP .and. Z->TDS=NDS .and. .not. eof()

         @ 15,32 say str(recno(),5)+"/"+str(reccount(),5)+" "
         Set Color To /W+
         @ 18,22,18,int(45*recno()/reccount())+22 box ""
         replace Z->OT with NTI
         NTI=NTI+1
         skip

      enddo

      NDS=Z->TDS

   enddo

   NGP=Z->TGP

enddo

copy to TITRES
Use TITRES
@15,32 say " Rindexe TITRES  "
set index to TITRE,ORTIT
Reindex
Use
delete file (CurDir+"Z.*")
@15,11 To 15,68
@15,32 say "Termin "

do RSTSCR
do BACAFF with "Remembrement termin.",10
Return
