*****************************************************************************
*
*                  D S C 1
*
*****************************************************************************

Procedure DSC1

select 1
use GROUPES index GROUPE,NOGRP
select 3
use GENRES index GENRE,GCLAIR
select 1

alphabet="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz"

do while .T.

   set relation to genre into GENRES
   e=recno()

   do BACDLIS1 with 1,0,10,70,space(15)+"Auteur"+space(32)+"Genre"

   l=3

   do while l<10 .and. .not. eof()
      @l,2 say "    "+left(dsc_grp(GROUPES->GROUPE)+space(40),40)+"  ";
           +GENRES->GCLAIR
      l=l+1
      skip
   enddo

   do BACDLIS2 with 1,0,10,70,e

   l=3
   cle=0

   set color to &CRIEN
   @24,0
   @24,2 say "[+] => Mmo, [Space] => Rech., "+ ;
             "[-] => Rech. disque, [=] => Rech. titre"

   HelpKey="AUTEURS"
   do BACRLIST with 3,10,0,l,alphabet+" "+chr(13)+chr(7)+chr(22)+ ;
                    chr(9)+"+-="+chr(19)+chr(4),cle

   do case
      case cle=27 .or. cle=19 .or. cle=4
           exit

      case cle=13
           do DISQUES with l+1

      case cle=7
           do DESTGRP with l+1,e

      case cle=22
           do INSGRP with e

      case cle=9
           do MODGRP with l

      case cle=32
           mgrp=GROUPES->GROUPE
           @l,6 get mgrp picture "@!"
           do_read()
           if mod(readkey(),128)=12
              loop
           endif
           e=recno()
           seek trim(mgrp)
           if .not. found()
              do BACERR with "Cet auteur n'existe pas!",l+1
              go e
           endif

      case chr(cle)="-"
           do RCHDSC

      case chr(cle)="="
           do RCHTITG

      case chr(cle)="+"
           do MEMOGRP with l+1

      case chr(cle) $ alphabet
           keyboard " "+chr(25)+chr(cle)

   endcase

enddo

close all
select 1
fin=chr(cle)

return

*****************************************************************************
*
*                  D E S T G R P
*
*****************************************************************************

Procedure DESTGRP

parameters lg,enr

set color to &CRIEN
@24,0

set color to &BGPSB
@lg-1,2 say "    "+left(dsc_grp(GROUPES->GROUPE)+space(40),40)+"  "+ ;
         GENRES->GCLAIR

e=recno()
skip
enr1=recno()
if eof()
   go e
   skip -1
   if bof()
      do bacerr with "Dernier auteur, suppression impossible!",lg
      return
   endif
   enr1=recno()
endif
go e

select 2
use DISQUES index ORDSC
seek str(GROUPES->NOGRP,3)
if DISQUES->NOGROUP<>GROUPES->NOGRP
   y=.F.
else
   y=.T.
endif
use
select 1

x=.F.
if .not. y
   do BACON with "Detruire cet auteur?",lg,x
else
   do BACON with "Il y a des disques pour cet "+ ;
                 "auteur qui pourront tres perdus, dtruire?",lg,x
endif

if x
   do SAVSCR
   do BACPAT with "Suppression en cours.",lg
   if y
      select 2
      use DISQUES index DISQUE,ORDSC
      delete all for DISQUES->NOGROUP=GROUPES->NOGRP
      pack
      use
      select 1
   endif
   delete
   pack
   enr=enr1
   do RSTSCR
endif

go enr

return

*****************************************************************************
*
*                  I N S G R P
*
*****************************************************************************

Procedure INSGRP

Parameter enr

mgp=space(40)
mgr=space(20)
do savscr

do while .T.

   set color to &BSBGP
   @10,0,12,70 box "͵ "
   set color to &CRIEN
   @24,0
   @24,2 say "Esc => Fin"

   @11,6 get mgp picture "@!@K"
   @11,48 get mgr picture "@!"
   do_read()
   if mod(readkey(),128)=12
      exit
   endif

   seek trim(mgp)
   if GROUPES->GROUPE=mgp .and. found()
      x=.F.
      set color to &CRIEN
      @24,0
      do BACON with "Cet auteur existe dj, le rajouter?",12,x
      if .not. x
         loop
      endif
   endif

   set order to 2
   go bottom
   set order to 1
   ngp=GROUPES->NOGRP+1
   select 3
   set order to 2
   seek trim(left(mgr,4))
   cle=0

   if mgr<>GENRES->GCLAIR .or. .not. found()
      do savscr
      if .not. found()
         go top
      endif

      do while .T.

         e=recno()
         do BACDLIS1 with 10,50,18,79,space(7)+"Genre"
         l=12
         do while l<18 .and. .not. eof()
            @l,52 say "    "+GENRES->GCLAIR
            l=l+1
            skip
         enddo
         do BACDLIS2 with 10,50,18,79,e
         cle=0
         set color to &CRIEN
         @24,0
         @24,2 say "Esc => Annuler, Enter => Valider"
         do BACRLIST with 12,18,50,12,chr(13),cle
         if cle=27 .or. cle=13
            exit
         endif

      enddo

      do rstscr
   endif
   set order to 1
   select 1
   if cle=27
      loop
   endif
   append blank
   replace GROUPES->GROUPE with mgp,GROUPES->NOGRP with ngp, ;
           GROUPES->GENRE with GENRES->GENRE

   do BACDLIS1 with 1,0,10,70,space(15)+"Auteur"+space(32)+"Genre"

   l=10
   lenr=l
   enr=recno()
   do while l>7 .and. .not. bof()
      l=l-1
      skip -1
   enddo

   l=3
   do while l<10 .and. .not. eof()
      @l,2 say "    "+left(dsc_grp(GROUPES->GROUPE)+space(40),40)+"  ";
           +GENRES->GCLAIR
      if recno()=e
         lenr=l
      endif
      l=l+1
      skip
   enddo
   do BACDLIS2 with 1,0,10,70,e

   set color to &RPSBGP
   @lenr,2 say "  "+left(dsc_grp(GROUPES->GROUPE)+space(40),40)+"  ";
               +GENRES->GCLAIR

enddo

go enr
do rstscr

return

*****************************************************************************
*
*                  M O D G R P
*
*****************************************************************************

Procedure MODGRP

Parameter lmp

mgp=GROUPES->GROUPE
mgr=GENRES->GCLAIR
xyz=recno()

do while .T.

   set color to &CRIEN
   @24,0
   @24,2 say "Esc => Fin"

   @lmp,6 get mgp picture "@!"
   @lmp,48 get mgr picture "@!"
   do_read()
   if mod(readkey(),128)=12
      exit
   endif

   seek trim(mgp)
   if GROUPES->GROUPE=mgp .and. found() .and. recno()<>xyz
      x=.F.
      set color to &CRIEN
      @24,0
      do BACON with "Cet auteur existe dj, valider?",lmp+1,x
      if .not. x
         loop
      endif
   endif

   select 3
   set order to 2
   seek trim(left(mgr,4))
   cle=0

   if mgr<>GENRES->GCLAIR .or. .not. found()
      do savscr
      if .not. found()
         go top
      endif

      do while .T.

         e=recno()
         do BACDLIS1 with 10,50,18,79,space(7)+"Genre"
         l=12
         do while l<18 .and. .not. eof()
            @l,52 say "    "+GENRES->GCLAIR
            l=l+1
            skip
         enddo
         do BACDLIS2 with 10,50,18,79,e
         cle=0
         set color to &CRIEN
         @24,0
         @24,2 say "Esc => Annuler, Enter => Valider"
         do BACRLIST with 12,18,50,12,chr(13),cle
         if cle=27 .or. cle=13
            exit
         endif

      enddo

      do rstscr
   endif
   mgrn=GENRES->GENRE

   set order to 1
   select 1
   if cle=27
      loop
   endif
   go xyz
   replace GROUPES->GROUPE with mgp,GROUPES->GENRE with mgrn
   exit

enddo

return

*****************************************************************************
*
*                  R C H D S C
*
*****************************************************************************

Procedure RCHDSC

mds=space(40)
xrds=recno()
do savscr

set color to &CRIEN
@24,0
@24,2 say "Esc => Fin"
set color to &BSBGP
@10,0,12,70 box "͵ "
@11,2 say "Nom du disque :"

set color to &CRIEN
@11,19 get mds picture "@!"
do_read()

if mod(readkey(),128)=12
   do rstscr
   return
endif

select 2
use DISQUES
copy to DTMP for DISQUES->DISQUE=trim(mds) fields DISQUE,NOGROUP
use DTMP

do case
   case reccount()=0
        do BACERR with "Disque inexistant.",12

   case reccount()=1
        go top
        select 1
        set order to 2
        seek DTMP->NOGROUP
        set order to 1
        keyboard chr(13)+" "+chr(25)+mds

   otherwise
        index on DTMP->NOGROUP to DTMP.$$$
        go top
        xnogroup=-1
        xdisque="^^^^"

        do while .not. eof()
           if xnogroup=DTMP->NOGROUP .and. xdisque=DTMP->DISQUE
              delete
              skip
            else
              xnogroup=DTMP->NOGROUP
              xdisque=DTMP->DISQUE
              skip
           endif
        enddo

        pack
        go top
        if reccount()=1
           keyboard chr(13)+" "+chr(25)+mds
        endif

        do while .T.
           select 1
           set order to 2
           select 2
           set relation to DTMP->NOGROUP into GROUPES
           erd=recno()
           do BACDLIS1 with 12,0,18,79,space(15)+"Auteur"+space(32)+"Titre"
           lrd=14
           do while lrd<18 .and. .not. eof()
              @lrd,2 say "    "+left(dsc_grp(GROUPES->GROUPE)+space(30),30) ;
                         +"  "+DTMP->DISQUE
              lrd=lrd+1
              skip
           enddo
           do BACDLIS2 with 12,0,18,79,erd
           lrd=14
           @24,0
           @24,2 say "Esc => Abandon, Enter => Slctionner"
           do BACRLIST with 14,18,0,lrd," "+chr(13),cle
           if cle=27
              select 1
              go xrds
              exit
           endif
           if cle=13
              keyboard chr(13)+" "+chr(25)+mds
              exit
           endif
           if cle=32
              mgrp=GROUPES->GROUPE
              @lrd,6 get mgrp picture "@!"
              do_read()
              if mod(readkey(),128)=12
                 loop
              endif
              select 1
              set order to 1
              seek trim(mgrp)
              if .not. found()
                 do BACERR with "Cet auteur n'existe pas!",lrd+1
                 loop
              endif
              select 2
              xdt=recno()
              seek GROUPES->NOGRP
              if .not. found()
                 go xdt
                 do BACERR with "Cet auteur n'a pas de disque correspondant",;
                                lrd+1
                 loop
              endif
           endif
        enddo
        select 1
        set order to 1
        delete file (CurDir+"\DTMP.$$$")
        delete file (CurDir+"\DTMP.DBF")
endcase

select 2
use
select 1

do rstscr

return

*****************************************************************************
*
*                  R C H T I T G
*
*****************************************************************************

Procedure RCHTITG

mds=space(40)
do savscr

set color to &CRIEN
@24,0
@24,2 say "Esc => Fin"
set color to &BSBGP
@10,0,12,70 box "͵ "
@11,2 say "Titre de plage :"

set color to &CRIEN
@11,19 get mds picture "!XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX"
do_read()

if mod(readkey(),128)=12
   do rstscr
   return
endif

select 1
xrds=recno()
select 2
use TITRES
copy to TTMP for ltrim(trim(mds)) $ TITRES->TITRE fields ;
                 TITRE,TGP,TDS
use TTMP

do case
   case reccount()=0
        do BACERR with "Plage inexistante.",12

   case reccount()=1
        go top
        select 1
        set order to 2
        seek TTMP->TGP
        set order to 1
        keyboard chr(13)+"="+chr(25)+TTMP->TITRE

   otherwise
        index on TTMP->TGP to TTMP.$$$
        go top
        xnogroup=-1
        xtitre="^^^^"

        do while .not. eof()
           if xnogroup=TTMP->TGP .and. xtitre=TTMP->TITRE
              delete
              skip
            else
              xnogroup=TTMP->TGP
              xtitre=TTMP->TITRE
              skip
           endif
        enddo

        pack
        go top
        if reccount()=1
           keyboard chr(13)+"="+TTMP->TITRE
        endif

        select 9
        use DISQUES index NODSC
        do while .T.
           select 1
           set order to 2
           select 2
           set relation to TTMP->TGP into GROUPES
           erd=recno()
           do BACDLIS1 with 12,0,18,79,space(15)+"Auteur"+space(32)+"Titre"
           lrd=14
           do while lrd<18 .and. .not. eof()
              select 9
              seek str(TTMP->TGP,3)+str(TTMP->TDS,3)
              select 2
              @lrd,2 say "    "+ ;
                         left(trim(dsc_grp(GROUPES->GROUPE))+": "+ ;
                              +DISQUES->DISQUE+space(30),30) ;
                         +"  "+TTMP->TITRE
              lrd=lrd+1
              skip
           enddo
           do BACDLIS2 with 12,0,18,79,erd
           lrd=14
           @24,0
           @24,2 say "Esc => Abandon, Enter => Slctionner"
           do BACRLIST with 14,18,0,lrd," "+chr(13),cle
           if cle=27
              select 1
              go xrds
              exit
           endif
           if cle=13
              keyboard chr(13)+"="+chr(25)+TTMP->TITRE
              exit
           endif
           if cle=32
              mgrp=GROUPES->GROUPE
              @lrd,6 get mgrp picture "@!"
              do_read()
              if mod(readkey(),128)=12
                 loop
              endif
              select 1
              set order to 1
              seek trim(mgrp)
              if .not. found()
                 do BACERR with "Cet auteur n'existe pas!",lrd+1
                 loop
              endif
              select 2
              xdt=recno()
              seek GROUPES->NOGRP
              if .not. found()
                 go xdt
                 do BACERR with "Cet auteur n'a pas de disque correspondant",;
                                lrd+1
                 loop
              endif
           endif
        enddo
        select 9
        use
        select 1
        set order to 1
        delete file (CurDir+"\TTMP.$$$")
        delete file (CurDir+"\TTMP.DBF")
endcase

select 2
use
select 1

do rstscr

return

*****************************************************************************
*
*                  M E M O G R P
*
*****************************************************************************

Procedure MEMOGRP

Parameter lg

do SAVSCR

HelpKey="MEMO"
set color to &BGPSB
@l,2 say "    "+left(dsc_grp(GROUPES->GROUPE)+space(40),40)+"  ";
           +GENRES->GCLAIR
set color to &BSBGP
@lg,1 to 22,70
set color to &CRIEN
@24,0
@24,2 say "Esc => Fin sans sauvegarde, Ctrl+W => Fin avec sauvegarde"
set color to N/W
set cursor on

replace GROUPES->MEMOG with memoedit(GROUPES->MEMOG,lg+1,2,21,69)

set cursor off

do RSTSCR

return

*****************************************************************************
*
*                  D I S Q U E S
*
*****************************************************************************

Procedure DISQUES

Parameter lg

Public OneDeleted,NGrp,MaxDsc

Private DscSav

do SAVSCR

select 1
DscSav=recno()
NGrp=GROUPES->NOGRP

do BACPAT with "Slection dans le fichier des disques.",lg
set color to &BGPSB
@lg-1,2 say "    "+left(dsc_grp(GROUPES->GROUPE)+space(40),40)+"  "+ ;
            GENRES->GCLAIR
use
select 3
use
select 2
use DISQUES index DISQUE,ORDSC
set order to 2
seek str(NGrp,3)
copy to DTMP while DISQUES->NOGROUP=NGrp
select 4
use TYPES index TVISIT,TYPE
set order to 2
select 5
use DTMP
go top
MaxDsc=0
do while .not. eof()
   MaxDsc=Max(MaxDsc,DTMP->NODSC)
   skip
enddo
go top
MaxDsc=MaxDsc+1
OneDeleted=.F.

if eof()
   x=.T.
   do BACON with " Cet auteur n'a pas de disque, saisir? ",lg,x
   if .not. x
      use
      select 1
      use GROUPES index GROUPE,NOGRP
      select 3
      use GENRES index GENRE,GCLAIR
      select 2
      use
      select 4
      use
      select 1
      go DscSav
      do RSTSCR
      return
   endif
   keyboard chr(22)
endif

alphabet="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz"

do while .T.

   HelpKey="DISQUES"
   set relation to TYPE into TYPES
   e=recno()

   do BACDLIS1 with lg,2,16,79,space(3)+"Sort. Achat"+space(15)+"Disque"+ ;
                    space(27)+"Type"

   l=lg+2

   do while l<16 .and. .not. eof()
      @l,3 say "    "+str(DTMP->ANSORTIE,2)+space(4)+ ;
           str(DTMP->ANACHAT,2)+space(3)+DTMP->DISQUE+" "+TYPES->TCLAIR
      l=l+1
      skip
   enddo

   do BACDLIS2 with lg,2,16,79,e

   l=lg+2
   cle=0

   set color to &CRIEN
   @24,0
   @24,2 say "[+] => Mmo, [Space] => Rech.,"+ ;
             " [=] => Rech. titre, [Return] => Titres"

   do BACRLIST with lg+2,16,2,l,alphabet+"+= "+ ;
               chr(13)+chr(7)+chr(22)+chr(9),cle

   do case
      case cle=27
           exit

      case cle=13
           do TITRES with l+1

      case cle=7
           do DESTDSC with l+1,e

      case cle=9
           do MODDSC with l

      case cle=22
           if INSDSC(e,lg)
              exit
           endif

      case cle=asc("+")
           do MEMODSC with l+1

      case cle=asc("=")
           do RECHTITD

      case cle=32
           mdsc=DTMP->DISQUE
           @l,18 get mdsc picture "@!"
           do_read()
           if mod(readkey(),128)=12
              loop
           endif
           e=recno()
           locate for DTMP->DISQUE=trim(mdsc)
           if eof()
              do BACERR with "Ce disque n'existe pas pour cet auteur!",l+1
              go e
           endif

      case chr(cle) $ alphabet
           keyboard " "+chr(25)+chr(cle)

   endcase

enddo

do RSTSCR
set filter to

select 5
use

select 2
if OneDeleted
   do SAVSCR
   do BACPAT with "Compactage des suppresions.",int((lg+20)/2)
   pack
   do RSTSCR
endif
use

select 4
use

select 1
use GROUPES index GROUPE,NOGRP
select 3
use GENRES index GENRE,GCLAIR
select 1
go DscSav

return

*****************************************************************************
*
*                  M E M O D S C
*
*****************************************************************************

Procedure MEMODSC

Parameter lg

do SAVSCR

HelpKey="MEMO"
set color to &BGPSB
@l,3 say "    "+str(DTMP->ANSORTIE,2)+space(4)+ ;
         str(DTMP->ANACHAT,2)+space(3)+DTMP->DISQUE+" "+TYPES->TCLAIR
set color to &BSBGP
@lg,10 to 22,69
set color to &CRIEN
@24,0
@24,2 say "Esc => Fin sans sauvegarde, Ctrl+W => Fin avec sauvegarde"
set color to N/W
set cursor on

replace DTMP->MEMO with memoedit(DTMP->MEMO,lg+1,11,21,68)
select 2
set order to 2
seek str(DTMP->NOGROUP,3)+str(DTMP->ANSORTIE,2)+str(DTMP->ANACHAT,2)+ ;
     DTMP->DISQUE
replace DISQUES->MEMO with DTMP->MEMO
set order to 1
select 5

set cursor off

do RSTSCR

return

*****************************************************************************
*
*                  D E S T D S C
*
*****************************************************************************

Procedure DESTDSC

parameters lg,enr

set color to &CRIEN
@24,0

set color to &BGPSB
@lg-1,3 say "    "+str(DTMP->ANSORTIE,2)+space(4)+ ;
         str(DTMP->ANACHAT,2)+space(3)+DTMP->DISQUE+" "+TYPES->TCLAIR

tde=recno()
skip
enr=recno()
der=.F.

if eof()
   go bottom
   skip -1
   if bof()
      der=.T.
   endif
   enr=recno()
endif

x=.T.
if .not. der
   do BACON with "Detruire ce disque?",lg,x
else
   do BACON with "Dernier disque de cet auteur, dtruire?",lg,x
   if x
      keyboard chr(27)
   endif
endif
go tde

if x
   select 2
   set order to 2
   seek str(DTMP->NOGROUP,3)+str(DTMP->ANSORTIE,2)+str(DTMP->ANACHAT,2)+ ;
        DTMP->DISQUE
   set order to 1
   delete
   OneDeleted=.T.
   select 5
   go tde
   delete
   if .not. der
      go enr
   else
      keyboard chr(27)
   endif
endif

if eof()
   go bottom
endif

return

*****************************************************************************
*
*                  I N S D S C
*
*****************************************************************************

Function INSDSC

Parameter enr,lg

mas=60
maa=mod(year(date()),100)
mds=space(40)
mty=space(4)
do savscr

do while .T.

   set color to &BSBGP
   @16,2,18,79 box "͵ "
   set color to &CRIEN
   @24,0
   @24,2 say "Esc => Fin"

   @17,7 get mas picture "99"
   @17,13 get maa picture "99"
   @17,18 get mds picture "@!@K"
   @17,64 get mty picture "@!"
   do_read()
   if mod(readkey(),128)=12
      exit
   endif

   select 4
   set order to 1
   seek trim(mty)
   set order to 2
   if mty<>TYPES->TVISIT .or. .not. found()
      do savscr
      if .not. found()
         go top
      endif

      do while .T.

         efg1=recno()
         do BACDLIS1 with 12,48,20,77,space(7)+"Type"
         l=14
         do while l<20 .and. .not. eof()
            @l,52 say "    "+TYPES->TCLAIR
            l=l+1
            skip
         enddo
         do BACDLIS2 with 12,48,20,77,efg1
         cle=0
         set color to &CRIEN
         @24,0
         @24,2 say "Esc => Annuler, Enter => Valider"
         do BACRLIST with 14,20,48,14,chr(13),cle
         if cle=27 .or. cle=13
            exit
         endif

      enddo

      do rstscr
   endif

   select 2
   if cle=27
      cle=0
      loop
   endif

   append blank
   replace DISQUES->DISQUE with mds,DISQUES->ANSORTIE with mas, ;
           DISQUES->ANACHAT with maa,DISQUES->TYPE with TYPES->TYPE, ;
           DISQUES->PRETE with .F.,DISQUES->NOGROUP with NGrp
   replace DISQUES->NODSC with MaxDsc

   select 5
   append blank
   replace DTMP->DISQUE with mds,DTMP->ANSORTIE with mas, ;
           DTMP->ANACHAT with maa,DTMP->TYPE with TYPES->TYPE, ;
           DTMP->PRETE with .F.,DTMP->NOGROUP with NGrp
   replace DTMP->NODSC with MaxDsc

   MaxDsc=MaxDsc+1
   set relation to TYPE into TYPES

   do BACDLIS1 with lg,2,16,79,space(3)+"Sort. Achat"+space(15)+"Disque"+ ;
                    space(27)+"Type"

   l=16
   lenr=lg+2
   eer=recno()
   do while l>lg+3 .and. .not. bof()
      l=l-1
      skip -1
   enddo

   l=lg+2
   do while l<16 .and. .not. eof()
      @l,3 say "    "+str(DTMP->ANSORTIE,2)+space(4)+ ;
           str(DTMP->ANACHAT,2)+space(3)+DTMP->DISQUE+" "+TYPES->TCLAIR
      if recno()=eer
         lenr=l
      endif
      l=l+1
      skip
   enddo
   do BACDLIS2 with lg,2,16,79,eer

   set color to &RPSBGP
   @lenr,3 say "  "+str(DTMP->ANSORTIE,2)+space(4)+ ;
           str(DTMP->ANACHAT,2)+space(3)+DTMP->DISQUE+" "+TYPES->TCLAIR

enddo

go top
x=eof()
go enr
do rstscr

return x

*****************************************************************************
*
*                  M O D D S C
*
*****************************************************************************

Procedure MODDSC

Parameter lg

mas=DTMP->ANSORTIE
maa=DTMP->ANACHAT
mds=DTMP->DISQUE
mty=TYPES->TVISIT
xyx=recno()

do while .T.

   set color to &BSBGP
   @lg,59 say space(20)
   set color to &CRIEN
   @24,0
   @24,2 say "Esc => Fin"

   @lg, 7 get mas picture "99"
   @lg,13 get maa picture "99"
   @lg,18 get mds picture "@!"
   @lg,59 get mty picture "@!"
   do_read()
   if mod(readkey(),128)=12
      exit
   endif

   select 4
   set order to 1
   seek trim(mty)
   set order to 2
   if mty<>TYPES->TVISIT .or. .not. found()
      do savscr
      if .not. found()
         go top
      endif

      do while .T.

         efg1=recno()
         do BACDLIS1 with 12,48,20,77,space(7)+"Type"
         l=14
         do while l<20 .and. .not. eof()
            @l,52 say "    "+TYPES->TCLAIR
            l=l+1
            skip
         enddo
         do BACDLIS2 with 12,48,20,77,efg1
         cle=0
         set color to &CRIEN
         @24,0
         @24,2 say "Esc => Annuler, Enter => Valider"
         do BACRLIST with 14,20,48,14,chr(13),cle
         if cle=27 .or. cle=13
            exit
         endif

      enddo

      do rstscr
   endif
   mtyn=TYPES->TYPE

   select 5
   go xyx
   if cle=27
      loop
   endif

   select 2
   set order to 2
   seek str(DTMP->NOGROUP,3)+str(DTMP->ANSORTIE,2)+str(DTMP->ANACHAT,2)+ ;
        DTMP->DISQUE
   set order to 1
   replace DISQUES->DISQUE with mds,DISQUES->ANSORTIE with mas, ;
           DISQUES->ANACHAT with maa,DISQUES->TYPE with mtyn

   select 5
   replace DTMP->DISQUE with mds,DTMP->ANSORTIE with mas, ;
           DTMP->ANACHAT with maa,DTMP->TYPE with mtyn

   set relation to TYPE into TYPES
   exit

enddo

cle=0

return


*****************************************************************************
*
*                  R E C H T I T D
*
*****************************************************************************

Procedure RECHTITD

mt=space(40)
do SAVSCR

set color to &BSBGP
@16,2,18,79 box "͵ "
set color to &CRIEN
@24,0
@24,2 say "Esc => Fin"
set color to &BSBGP

@17,4 say "Titre de plage :" get mt;
      picture "!XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX"
set color to
do_read()
if mod(readkey(),128)=12
   do RSTSCR
   return
endif

select 9
use TITRES index TITRE
seek trim(mt)
do while TITRES->TITRE=trim(mt) .and. TITRES->TGP<>NGrp
   skip
enddo
if TITRES->TITRE<>trim(mt)
   do BACERR with "Plage inexistante.",12
else
   x=TITRES->TDS
   select 5
   locate for DTMP->NODSC=x
   keyboard chr(13)+" "+chr(25)+mt
endif

select 9
use
select 5

do RSTSCR

return

*****************************************************************************
*
*                  T I T R E S
*
*****************************************************************************

Procedure TITRES

Parameter lgt

Public OneTDeleted,NDis,MaxTit

Private TitSav,ligech

ligech=-1
select 5
TitSav=recno()
NDis=DTMP->NODSC

do SAVSCR

do BACPAT with "Slection dans le fichier des titres.",lgt
set color to &BGPSB
@lgt-1,4 say "   "+str(DTMP->ANSORTIE,2)+space(4)+ ;
     str(DTMP->ANACHAT,2)+space(3)+DTMP->DISQUE+" "+TYPES->TCLAIR
use
select 4
use
select 5
use
select 6
use TITRES index TITRE,ORTIT
set order to 2
copy to TTMP for TITRES->TGP=NGrp .and. TITRES->TDS=NDis
select 7
use TTMP
go bottom
MaxTit=TTMP->OT+1
go top
MaxTit=iif(eof(),0,MaxTit)
OneTDeleted=.F.

if eof()
   x=.T.
   do BACON with " Ce disque n'a pas de titre, saisir ?",lgt,x
   if .not. x
      do RSTSCR
      use
      select 6
      use
      select 2
      use DISQUES index DISQUE,ORDSC
      select 4
      use TYPES index TVISIT,TYPE
      set order to 2
      select 5
      use DTMP
      set relation to TYPE into TYPES
      go TitSav
      return
   endif
   keyboard chr(22)
endif

alphabet="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz"

do while .T.

   HelpKey="TITRES"
   e=recno()

   do BACDLIS1 with lgt,4,20,61,space(20)+"Titre"+space(21)+"Dure"

   l=lgt+2

   do while l<20 .and. .not. eof()
      @l,5 say "    "+TTMP->TITRE+"  "+TTMP->DURE
      if ligech=recno()
         @l,8 say "*"
      endif
      l=l+1
      skip
   enddo

   do BACDLIS2 with lgt,2,20,61,e

   l=lgt+2
   cle=0

   set color to &CRIEN
   @24,0
   @24,2 say "[+] => Mmo, [Space] => Rech.,"+ ;
             " [*] => Echange, [Return] => Temps et etiquette"

   do BACRLIST with lgt+2,20,4,l,alphabet+"+* "+chr(7)+ ;
                    chr(22)+chr(9),cle

   do case
      case cle=27
           exit

      case cle=7
           do DESTTIT with l+1,e

      case cle=9
           do MODTIT with l

      case cle=22
           if INSTIT(e,lgt)
              exit
           endif

      case cle=asc("+")
           do MEMOTIT with l+1

      case cle=asc("*")
           do ECHTIT

      case cle=13
           do ETIQTIT with l+1

      case cle=32
           mtit=TTMP->TITRE
           @l,9 get mtit picture "!XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX"
           do_read()
           if mod(readkey(),128)=12
              loop
           endif
           e=recno()
           locate for TTMP->TITRE=trim(mtit)
           if eof()
              do BACERR with "Ce titre n'existe pas pour ce disque!",l+1
              go e
           endif

      case chr(cle) $ alphabet
           keyboard " "+chr(25)+chr(cle)

   endcase

enddo

do RSTSCR
set filter to

select 7
use

select 6
if OneTDeleted
   do SAVSCR
   do BACPAT with "Compactage des suppressions.",int((lgt+20)/2)
   set order to 2
   seek str(NGrp,3)+str(NDis,3)
   x=1
   do while TITRES->TGP=NGrp .and. TITRES->TDS=NDis
      if .not. deleted()
         replace TITRES->OT with x
         x=x+1
      endif
   enddo
   pack
   do RSTSCR
endif
use

select 2
use DISQUES index DISQUE,ORDSC
select 4
use TYPES index TVISIT,TYPE
set order to 2
select 5
use DTMP
set relation to TYPE into TYPES
go TitSav

return

*****************************************************************************
*
*                  M E M O T I T
*
*****************************************************************************

Procedure MEMOTIT

Parameter lgt

do SAVSCR

HelpKey="MEMO"
set color to &BGPSB
@l,5 say "    "+TTMP->TITRE+"  "+TTMP->DURE
set color to &BSBGP
@lgt,10 to 22,69
set color to &CRIEN
@24,0
@24,2 say "Esc => Fin sans sauvegarde, Ctrl+W => Fin avec sauvegarde"
set color to N/W
set cursor on

replace TTMP->MEMOT with memoedit(TTMP->MEMOT,lgt+1,11,21,68)
select 6
set order to 2
seek str(TTMP->TGP,3)+str(TTMP->TDS,3)+str(TTMP->OT,2)
replace TITRES->MEMOT with TTMP->MEMOT
set order to 1
select 7

set cursor off

do RSTSCR

return

*****************************************************************************
*
*                  D E S T T I T
*
*****************************************************************************

Procedure DESTTIT

parameters lgt,enr

set color to &CRIEN
@24,0

set color to &BGPSB
@lgt-1,5 say "    "+TTMP->TITRE+"  "+TTMP->DURE

tde=recno()
skip
enr=recno()
der=.F.

if eof()
   go bottom
   skip -1
   if bof()
      der=.T.
   endif
   enr=recno()
endif

x=.T.
if .not. der
   do BACON with "Detruire ce titre?",lgt,x
else
   do BACON with "Dernier titre de ce disque, dtruire?",lgt,x
   if x
      keyboard chr(27)
   endif
endif
go tde

if x
   select 6
   set order to 2
   seek str(TTMP->TGP,3)+str(TTMP->TDS,3)+str(TTMP->OT,2)
   delete
   set order to 1
   OneTDeleted=.T.
   select 7
   go tde
   delete
   if .not. der
      go enr
   else
      keyboard chr(27)
   endif
endif

if eof()
   go bottom
endif

return

*****************************************************************************
*
*                  E C H T I T
*
*****************************************************************************

Procedure ECHTIT

if ligech=-1

   ligech=recno()
   @ l,8 say "*"

else

   tdpm1=TTMP->TGP
   tdsm1=TTMP->TDS
   durem1=TTMP->DURE
   titrem1=TTMP->TITRE
   memotm1=TTMP->MEMOT

   ligechm=recno()
   go ligech
   ligech=-1

   tdpm2=TTMP->TGP
   tdsm2=TTMP->TDS
   durem2=TTMP->DURE
   titrem2=TTMP->TITRE
   memotm2=TTMP->MEMOT

   select 6
   set order to 2
   seek str(TTMP->TGP,3)+str(TTMP->TDS,3)+str(TTMP->OT,2)
   set order to 1
   replace TITRES->TGP with tdpm1,TITRES->TDS with tdsm1, ;
           TITRES->DURE with durem1,TITRES->TITRE with titrem1, ;
           TITRES->MEMOT with memotm1


   select 7
   replace TTMP->TGP with tdpm1,TTMP->TDS with tdsm1, ;
           TTMP->DURE with durem1,TTMP->TITRE with titrem1, ;
           TTMP->MEMOT with memotm1


   go ligechm

   select 6
   set order to 2
   seek str(TTMP->TGP,3)+str(TTMP->TDS,3)+str(TTMP->OT,2)
   set order to 1
   replace TITRES->TGP with tdpm2,TITRES->TDS with tdsm2, ;
           TITRES->DURE with durem2,TITRES->TITRE with titrem2, ;
           TITRES->MEMOT with memotm2


   select 7
   replace TTMP->TGP with tdpm2,TTMP->TDS with tdsm2, ;
           TTMP->DURE with durem2,TTMP->TITRE with titrem2, ;
           TTMP->MEMOT with memotm2


endif

return

*****************************************************************************
*
*                  I N S T I T
*
*****************************************************************************

Function INSTIT

Parameter enr,lgt

mtit=space(40)
mtmp=space(5)
do savscr

do while .T.

   set color to &BSBGP
   @20,4,22,61 box "͵ "
   set color to &CRIEN
   @24,0
   @24,2 say "Esc => Fin"

   @21,9 get mtit picture "@K !XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX"
   @21,51 get mtmp picture "99'99"
   do_read()
   mtmp=str0(val(left(mtmp,2)),2)+"'"+str0(val(right(mtmp,2)),2)
   if mod(readkey(),128)=12
      exit
   endif

   if cle=27
      cle=0
      loop
   endif

   select 6
   append blank
   replace TITRES->TITRE with mtit,TITRES->DURE with mtmp, ;
           TITRES->TGP with NGrp,TITRES->TDS with NDis, ;
           TITRES->OT with MaxTit

   select 7
   append blank
   replace TTMP->TITRE with mtit,TTMP->DURE with mtmp, ;
           TTMP->TGP with NGrp,TTMP->TDS with NDis, ;
           TTMP->OT with MaxTit

   MaxTit=MaxTit+1

   do BACDLIS1 with lgt,4,20,61,space(20)+"Titre"+space(20)+"Dure"

   l=20
   eer=recno()
   do while l>lgt+4 .and. .not. bof()
      l=l-1
      skip -1
   enddo

   l=lgt+2
   do while l<20 .and. .not. eof()
      @l,5 say "    "+TTMP->TITRE+"  "+TTMP->DURE
      if recno()=eer
         lenr=l
      endif
      l=l+1
      skip
   enddo
   do BACDLIS2 with lgt,2,20,61,eer

   set color to &RPSBGP
   @lenr,5 say "  "+TTMP->TITRE+"  "+TTMP->DURE

enddo

go top
x=eof()
go enr
do rstscr

return x

*****************************************************************************
*
*                  M O D T I T
*
*****************************************************************************

Procedure MODTIT

Parameter lgtl

mtit=TTMP->TITRE
mtmp=TTMP->DURE
xyx=recno()

do while .T.

   set color to &BSBGP
   set color to &CRIEN
   @24,0
   @24,2 say "Esc => Fin"

   @lgtl,9 get mtit picture "!XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX"
   @lgtl,51 get mtmp picture "99'99"
   do_read()
   mtmp=str0(val(left(mtmp,2)),2)+"'"+str0(val(right(mtmp,2)),2)
   if mod(readkey(),128)=12
      exit
   endif

   if cle=27
      loop
   endif

   select 6
   set order to 2
   seek str(TTMP->TGP,3)+str(TTMP->TDS,3)+str(TTMP->OT,2)
   set order to 1
   replace TITRES->TITRE with mtit,TITRES->DURE with mtmp

   select 7
   replace TTMP->TITRE with mtit,TTMP->DURE with mtmp

   exit

enddo

cle=0

return


*****************************************************************************
*
*                  E T I Q T I T
*
*****************************************************************************

Procedure ETIQTIT

Parameter ltm

set color to &BGPSB
@ltm-1,7 say "  "+TTMP->TITRE+"  "+TTMP->DURE+"  "
icitemp=recno()
otm1=TTMP->OT
sum val(left(TTMP->DURE,2)) to min_t for TTMP->TGP=NGrp ;
    .and. TTMP->TDS=NDis .and. TTMP->OT<=otm1
sum val(right(TTMP->DURE,2)) to sec_t for TTMP->TGP=NGrp ;
    .and. TTMP->TDS=NDis .and. TTMP->OT<=otm1
min_t=min_t+int(sec_t/60)
sec_t=mod(sec_t,60)
hr_t=int(min_t/60)
min_t=mod(min_t,60)

Mess="Temps: "+str(hr_t,2)+"h "+str0(min_t,2)+"' "+ ;
     str0(sec_t,2)+'", reste: '
sum val(left(TTMP->DURE,2)) to min_tb for TTMP->TGP=NGrp ;
    .and. TTMP->TDS=NDis .and. TTMP->OT>otm1
sum val(right(TTMP->DURE,2)) to sec_tb for TTMP->TGP=NGrp ;
    .and. TTMP->TDS=NDis .and. TTMP->OT>otm1
min_tb=min_tb+int(sec_tb/60)
sec_tb=mod(sec_tb,60)
hr_tb=int(min_tb/60)
min_tb=mod(min_tb,60)
go icitemp

x=.F.
do BACON with Mess+str(hr_tb,2)+"h "+str0(min_tb,2)+"' "+ ;
              str0(sec_tb,2)+'", Editer?',ltm,x
if .not. x
   return
endif

do SAVSCR

large=42
haut=13
tranche=2
car1="   "
car2="   "
car3="   "
Set Color to &BGPSB
@ ltm,6 clear to ltm+4,59
@ ltm,6 to ltm+4,59 double

@ltm+1, 8 say "Largeur du papier  . :" get large   picture "@K 99"
@ltm+2, 8 say "Hauteur du papier  . :" get haut    picture "@K 99"
@ltm+3, 8 say "Hauteur de la tranche:" get tranche picture "@K 99"
@ltm+1,35 say "Squences de dbut:"    get car1    picture "@K 999"
@ltm+2,35 say " . . . . . . . .   "    get car2    picture "@K 999"
@ltm+3,35 say " . . . . . . . .   "    get car2    picture "@K 999"

Set Color To
do_read()

do RSTSCR

if mod(ReadKey(),128)=12
   return
endif

large=large+mod(large,2)
large=min(max(large,20),70)
haut=min(max(haut,5),20)
do BACISP with ltm,x
if x
   return
endif

do SAVSCR
do BACPAT with "Edition en cours.",ltm
set console off
go top
s1=recno()
xttt1=trim(TTMP->TITRE)
xtt1=" "
s2=icitemp
go s2
xttt2=trim(TTMP->TITRE)
xtt2=" "
x1=.T.
x2=.T.
ligetq=0
select 99
use DTMP
go TitSav
ds=trim(DTMP->DISQUE)
use GROUPES
go DscSav
gp=trim(dsc_grp(GROUPES->GROUPE))
use
select 7
set print on

escape_seq=""
if car1<>Space(3)
   escape_seq=escape_seq+chr(val(car1))
endif
if car2<>Space(3)
   escape_seq=escape_seq+chr(val(car2))
endif
if car3<>Space(3)
   escape_seq=escape_seq+chr(val(car3))
endif
? escape_seq

sec_tb=sec_t+sec_tb
min_tb=min_tb+min_t
hr_tb =hr_tb+hr_t
min_tb=min_tb+int(sec_t/60)
sec_tb=mod(sec_tb,60)
hr_tb=int(min_tb/60)+hr_tb
min_tb=mod(min_tb,60)
Mess=str(hr_tb,2)+"h "+str0(min_tb,2)+"' "+str0(sec_tb,2)+'"'
?
? space(10)+""+replicate("",Large-1)+""
? space(10)+""+left("   Date : "+dtoc(date())+space(Large-1),Large-1)+""
? space(10)+""+left("   Temps: "+Mess+space(Large-1),Large-1)+""
? space(10)+""+replicate("",Large-1)+""
? space(10)+""+space(int(Large/2)-1-len(gp)/2)+gp+ ;
  space(int(Large/2)-1-len(gp)/2+mod(len(gp),2))+" "
? space(10)+""+space(int(Large/2)-1-len(ds)/2)+ds+;
  space(int(large/2)-1-len(ds)/2+mod(len(ds),2))+" "
? space(10)+""+replicate("",(Large/2)-1)+""+;
  replicate("",int(Large/2)-1)+""

do while .T.
   go s1
   if x1
      if len(xttt1) > 1
         do K7PART with xtt1,xttt1
       else
         skip
         if recno()=icitemp
            x1  =.F.
            xtt1=space(int(Large/2)-1)
          else
            xttt1=trim(TTMP->TITRE)
            do K7PART with xtt1,xttt1
            s1   =recno()
         endif
      endif
    else
      xtt1=space(int(Large/2)-1)
   endif

   go s2
   if x2
      if len(xttt2) > 1
         do K7PART with xtt2,xttt2
       else
         skip
         if eof()
            x2  =.F.
            xtt2=space(int(Large/2)-1)
          else
            xttt2=trim(TTMP->TITRE)
            do K7PART with xtt2,xttt2
            s2   =recno()
         endif
      endif
    else
      xtt2=space(int(Large/2)-1)
   endif

   ? space(10)+""+xtt1+""+xtt2+""
   ligetq=ligetq+1
   if ligetq>haut
      ligetq=0
      ? space(10)+""+replicate("",int(Large/2)-1)+""+;
        replicate("",int(Large/2)-1)+""
      if .not. (x1 .or. x2)
         exit
      endif
      ? space(10)+""+replicate("",int(Large/2)-1)+""+;
        replicate("",int(Large/2)-1)+""
   endif
enddo

?
set print off
set console on
do RSTSCR
go icitemp

return

*****************************************************************************

Procedure K7PART

Parameters xtt,xttt

Private tempx

xtt =left(xttt,int(Large/2)-1)
xttt=right(xttt,len(xttt)-int(Large/2)+1)
if " " $ xtt .and. len(xttt) > 0
   do while right(xtt,1) <> " " .and. left(xttt,1) <> " " ;
      .and. len(xtt) > 0
      tempx=right(xtt,1)
      xtt  =left(xtt,len(xtt)-1)
      xttt =tempx+xttt
   enddo
endif
xtt =left(xtt+space(int(Large/2)),int(Large/2)-1)
xttt=" "+ltrim(xttt)

return
