*****************************************************************************
*
*                  D S C 2
*
*****************************************************************************

Procedure DSC2

q200000=space(8)

do while .T.

   HelpKey="PARAMETRES"
   fin=chr(4)+chr(19)
   do MN200000 with l200000,q200000,fin

   if q200000="********" .or. fin $ chr(4)+chr(19)
      exit
   endif

   do SAVSCR

   do case

      case q200000="GENRES  "
           do GENRES

      case q200000="TYPES   "
           do TYPES

      case q200000="FGENRE  "
           set deleted off
           do FGENRE

      case q200000="FTYPE   "
           set deleted off
           do FTYPE

      case q200000="FGROUPE "
           set deleted off
           do FGROUPE

      case q200000="ANNEES  "
           do FANNEES

   endcase
   set deleted on

   do RSTSCR

enddo

return

*****************************************************************************
*
*                  G E N R E S
*
*****************************************************************************

Procedure GENRES

select 1
use GROUPES
select 3
use GENRES index GENRE,GCLAIR
set order to 2

alphabet="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz"

do while .T.

   HelpKey="GENRES"
   e=recno()

   do BACDLIS1 with 3,25,16,50,space(8)+"Genre"

   l=5

   do while l<16 .and. .not. eof()
      @l,26 say "    "+GENRES->GCLAIR
      l=l+1
      skip
   enddo

   do BACDLIS2 with 3,25,16,50,e

   l=5
   cle=0

   set color to &CRIEN
   @24,0
   @24,2 say "Esc => Retour, Space => Recherche, "+ ;
             "Ins => Ajout, Del => Suppression"

   do BACRLIST with 5,16,25,l,alphabet+" "+chr(7)+chr(22),cle

   do case
      case cle=27
           exit

      case cle=7
           do DESTGRE with l+1,e

      case cle=22
           do INSGRE with e

      case cle=32
           mgrp=GENRES->GCLAIR
           @l,30 get mgrp picture "@!"
           do_read()
           if mod(readkey(),128)=12
              loop
           endif
           e=recno()
           seek trim(mgrp)
           if .not. found()
              do BACERR with "Ce genre n'existe pas!",l+1
              go e
           endif

      case chr(cle) $ alphabet
           keyboard " "+chr(25)+chr(cle)

   endcase

enddo

close all
select 1

return

*****************************************************************************
*
*                  T Y P E S
*
*****************************************************************************

Procedure TYPES

select 2
use DISQUES
select 4
use TYPES index TVISIT,TYPE

alphabet="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz"

do while .T.

   HelpKey="TYPES"
   e=recno()

   do BACDLIS1 with 4,25,16,60,space(10)+"Type"+space(12)+"Code"

   l=6

   do while l<16 .and. .not. eof()
      @l,26 say "    "+TYPES->TCLAIR+"  "+TYPES->TVISIT
      l=l+1
      skip
   enddo

   do BACDLIS2 with 4,25,16,60,e

   l=6
   cle=0

   set color to &CRIEN
   @24,0
   @24,2 say "Esc => Retour, Space => Recherche, "+ ;
             "Ins => Ajout, Del => Suppression"

   do BACRLIST with 6,16,25,l,alphabet+" "+chr(7)+chr(22),cle

   do case
      case cle=27
           exit

      case cle=7
           do DESTTY with l+1,e

      case cle=22
           do INSTY with e

      case cle=32
           mgrp=TYPES->TCLAIR
           @l,30 get mgrp picture "!XXXXXXXXXXXXXXXXXXX"
           do_read()
           if mod(readkey(),128)=12
              loop
           endif
           e=recno()
           seek trim(mgrp)
           if .not. found()
              do BACERR with "Ce type n'existe pas!",l+1
              go e
           endif

      case chr(cle) $ alphabet
           keyboard " "+chr(25)+chr(cle)

   endcase

enddo

close all
select 1

return

*****************************************************************************
*
*                  I N S G R E
*
*****************************************************************************

Procedure INSGRE

Parameter enr

mgr=space(20)
do savscr

do while .T.

   set color to &BSBGP
   @16,25,18,50 box "͵ "
   set color to &CRIEN
   @24,0
   @24,2 say "Esc => Fin"

   @17,30 get mgr picture "@!@K"
   do_read()
   if mod(readkey(),128)=12
      exit
   endif

   seek left(mgr,4)
   if left(GENRES->GCLAIR,4)=left(mgr,4) .and. found()
      do BACERR with "Genre dupliqu (4 premires lettres)!",18
      loop
   endif

   set order to 1
   go bottom
   set order to 2
   ngr=GENRES->GENRE+1

   append blank
   replace GENRES->GENRE with ngr,GENRES->GCLAIR with mgr
   enr=recno()

   do BACDLIS1 with 3,25,16,50,space(8)+"Genre"

   l=16
   do while l>12 .and. .not. bof()
      l=l-1
      skip -1
   enddo

   l=5
   do while l<16 .and. .not. eof()
      @l,26 say "    "+GENRES->GCLAIR
      if recno()=enr
         lenr=l
      endif
      l=l+1
      skip
   enddo

   do BACDLIS2 with 3,25,16,50,enr
   set color to &RPSBGP
   @lenr,26 say "  "+GENRES->GCLAIR

enddo

go enr
do rstscr

return

*****************************************************************************
*
*                  D E S T G R E
*
*****************************************************************************

Procedure DESTGRE

Parameter lg,enr

Private e

e=recno()
select 1
locate for GROUPES->GENRE=GENRES->GENRE
if .not. eof()
   do BACERR with ;
      "Ce genre correspond  (au moins) un auteur, "+ ;
      "suppression impossible!",lg
else
   select 3
   go e
   skip
   if eof()
      go bottom
      skip -1
      if bof()
         do BACERR with "Dernier genre, suppression impossible!",lg
         go enr
         return
      endif
   endif
   enr=recno()
   go e
   x=.T.
   set color to &BGPSB
   @lg-1,26 say "    "+GENRES->GCLAIR
   do BACON with "Confirmez la suppression.",lg,x
   if x
      delete
      pack
   endif
endif

select 3
go enr

return

*****************************************************************************
*
*                  I N S T Y
*
*****************************************************************************

Procedure INSTY

Parameter enr

mty=space(20)
mtv=space(4)
do savscr

do while .T.

   set color to &BSBGP
   @16,25,18,60 box "͵ "
   set color to &CRIEN
   @24,0
   @24,2 say "Esc => Fin"

   @17,30 get mty picture "!XXXXXXXXXXXXXXXXXXX@K"
   @17,52 get mtv picture "@!"
   do_read()
   if mod(readkey(),128)=12
      exit
   endif

   seek trim(mtv)
   if TYPES->TVISIT=mtv .and. found()
      do BACERR with "Code de type dupliqu!",18
      loop
   endif

   locate for TYPES->TCLAIR=mty
   if .not. eof()
      do BACERR with "Type dupliqu!",18
      loop
   endif

   set order to 2
   go bottom
   set order to 1
   nty=TYPES->TYPE+1
   append blank
   replace TYPES->TVISIT with mtv,TYPES->TCLAIR with mty, ;
           TYPES->TYPE with nty
   enr=recno()

   do BACDLIS1 with 4,25,16,60,space(10)+"Type"+space(12)+"Code"

   l=16
   do while l>12 .and. .not. bof()
      l=l-1
      skip -1
   enddo

   l=6
   do while l<16 .and. .not. eof()
      @l,26 say "    "+TYPES->TCLAIR+"  "+TYPES->TVISIT
      if recno()=enr
         lenr=l
      endif
      l=l+1
      skip
   enddo

   do BACDLIS2 with 4,25,16,60,enr
   set color to &RPSBGP
   @lenr,26 say "  "+TYPES->TCLAIR+"  "+TYPES->TVISIT

enddo

go enr
do rstscr

return

*****************************************************************************
*
*                  D E S T T Y
*
*****************************************************************************

Procedure DESTTY

Parameter lg,enr

Private l,x

efg=recno()
select 2
locate for DISQUES->TYPE=TYPES->TYPE
if .not. eof()
   do BACERR with ;
      "Ce type est utilis par (au moins) "+ ;
      "un disque, suppression impossible!",lg
else
   select 4
   go efg
   skip
   if eof()
      go bottom
      skip -1
      if bof()
         do BACERR with "Dernier type, suppression impossible!",lg
         go enr
         return
      endif
   endif
   enr=recno()
   go efg
   x=.T.
   set color to &BGPSB
   @lg-1,26 say "    "+TYPES->TCLAIR+"  "+TYPES->TVISIT+"  "
   do BACON with "Confirmez la suppression.",lg,x
   if x
      delete
      pack
   endif
endif

select 4
go enr

return

*****************************************************************************
*
*                  F G E N R E
*
*****************************************************************************

Procedure FGENRE

select 12
use L_GR index I_GR
select 3
use GENRES index GENRE,GCLAIR
select 12

HelpKey="FILTRES"
go top
if eof()
   x=.F.
   do BACON with "Tout est slectionn, visualiser?",6,x
   if .not. x
      close all
      return
   endif
   select 3
   go top
   do while .not. eof()
      select 12
      append blank
      replace L_GR->GR with GENRES->GENRE
      select 3
      skip
   enddo
endif

select 12
set relation to GR into GENRES
go top

alphabet="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz"

do while .T.

   e=recno()

   do BACDLIS1 with 6,25,16,51,space(8)+"Genre"

   l=8

   do while l<16 .and. .not. eof()
      @l,26 say "   "+iif(deleted(),""," ")+GENRES->GCLAIR
      l=l+1
      skip
   enddo

   do BACDLIS2 with 6,25,16,51,e

   l=8
   cle=0

   set color to &CRIEN
   @24,0
   @24,1 say "^Home => Eff tout, ^End => Garde 1, "+ ;
             "BS => Eff., Del => Marque, Enter => Enlve"

   do while .T.

      do BACRLIST with 8,16,25,l,alphabet+" 28"+chr(7)+chr(22)+ ;
                       chr(8)+chr(29)+chr(23),cle

      set color to &BSBGP

      do case
         case cle=27
              exit

         case cle=29
              x=.F.
              do BACON with "Tout supprimer?",l+1,x
              if x
                 zap
                 pack
                 cle=27
                 exit
              endif

         case cle=23
              x=.F.
              do BACON with "N'en garder qu'un seul?",l+1,x
              if x
                 x=recno()
                 delete all
                 go x
                 recall
                 pack
                 exit
              endif

         case cle=8
              do DESTGR with e
              exit

         case cle=50
              keyboard chr(7)+chr(24)

         case cle=56
              keyboard chr(7)+chr(5)

         case cle=13
              recall
              @l,29 say " "

         case cle=7
              delete
              @l,29 say ""

         case cle=22
              do INSGR with e
              exit

         case cle=32
              mgrp=GENRES->GCLAIR
              @l,30 get mgrp picture "@!"
              set color to &CRIEN
              do_read()
              Set Color To &BSBGP
              if mod(readkey(),128)=12
                 @l,30 say GENRES->GCLAIR
                 loop
              endif
              e=recno()
              select 3
              set order to 2
              seek trim(left(mgrp,4))
              x=.not. found()
              ngr=GENRES->GENRE
              set order to 1
              select 12

              if x
                 do BACERR with "Ce genre n'existe pas!",l+1
                 go e
                 Set Color To &BSBGP
                 @l,30 say GENRES->GCLAIR
                 loop
              endif

              seek ngr
              if .not. found()
                 do BACERR with "Ce genre n'est pas slectionn!",l+1
                 go e
                 Set Color To &BSBGP
                 @l,30 say GENRES->GCLAIR
                 loop
              endif
              exit

         case chr(cle) $ alphabet
              keyboard " "+chr(25)+chr(cle)

         otherwise
              exit

      endcase

   enddo

   if cle=27
      exit
   endif

enddo

close all
select 1

return

*****************************************************************************
*
*                  I N S G R
*
*****************************************************************************

Procedure INSGR

Parameter enr

mgr=space(20)
do savscr

do while .T.

   set color to &BSBGP
   @16,25,18,51 box "͵ "
   set color to &CRIEN
   @24,0
   @24,2 say "Esc => Fin"

   @17,30 get mgr picture "@!@K"
   do_read()
   if mod(readkey(),128)=12
      exit
   endif

   cle=0
   select 3
   set order to 2
   seek trim(left(mgr,4))
   if GENRES->GCLAIR<>mgr .or. .not. found()
      do savscr
      if .not. found()
         go top
      endif

      do while .T.

         e=recno()
         do BACDLIS1 with 14,46,22,72,space(7)+"Genre"
         l=16
         do while l<22 .and. .not. eof()
            @l,47 say "    "+GENRES->GCLAIR
            l=l+1
            skip
         enddo
         do BACDLIS2 with 14,46,22,72,e
         cle=0
         set color to &CRIEN
         @24,0
         @24,2 say "Esc => Annuler, Enter => Valider"
         do BACRLIST with 16,22,46,16,chr(13),cle
         if cle=27 .or. cle=13
            exit
         endif

      enddo

      do rstscr
   endif

   ngr=GENRES->GENRE
   set order to 1
   select 12

   if cle=27
      cle=0
      loop
   endif

   seek ngr
   if found()
      do BACERR with "Ce genre est dj slectionn!",18
      loop
   endif

   append blank
   replace L_GR->GR with ngr
   enr=recno()

   e=recno()
   do BACDLIS1 with 7,25,16,51,space(8)+"Genre"

   l=16
   e=recno()
   do while l>12 .and. .not. bof()
      l=l-1
      skip -1
   enddo

   l=9
   do while l<16 .and. .not. eof()
      @l,26 say "    "+GENRES->GCLAIR
      if recno()=enr
         lenr=l
      endif
      l=l+1
      skip
   enddo

   do BACDLIS2 with 7,25,16,51,e
   set color to &RPSBGP
   @lenr,26 say "  "+GENRES->GCLAIR

enddo

go enr
do rstscr

return

*****************************************************************************
*
*                  D E S T G R
*
*****************************************************************************

Procedure DESTGR

Parameter enr

Private l,x

count for deleted() to x
go enr
if x=0
   do BACERR with "Pas de genre marqu!",16
   return
endif

l=8
ldel=15
set color to &BGPSB
do while l<16 .and. .not. eof()
   if deleted()
      @l,27 say "   "+GENRES->GCLAIR
      ldel=l
   endif
   l=l+1
   skip
enddo

x=.T.
do BACON with "Confirmez la suppression.",ldel+1,x
if x
   pack
   go top
   if eof()
      keyboard chr(27)
   endif
endif

go top

return

*****************************************************************************
*
*                  F T Y P E
*
*****************************************************************************

Procedure FTYPE

select 13
use L_TY index I_TY
select 4
use TYPES index TYPE,TVISIT
select 13

HelpKey="FILTRES"
go top
if eof()
   x=.F.
   do BACON with "Tout est slectionn, visualiser?",7,x
   if .not. x
      close all
      return
   endif
   select 4
   go top
   do while .not. eof()
      select 13
      append blank
      replace L_TY->TY with TYPES->TYPE,L_TY->VAL with 1
      select 4
      skip
   enddo
endif

select 13
set relation to TY into TYPES
go top

alphabet="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz"

do while .T.

   e=recno()

   do BACDLIS1 with 7,25,16,63,space(8)+"Type"+space(14)+"Code  Val."

   l=9

   do while l<16 .and. .not. eof()
      @l,26 say "   "+iif(deleted(),""," ")+ ;
                TYPES->TCLAIR+"  "+TYPES->TVISIT+"   "+str(L_TY->VAL,2)
      l=l+1
      skip
   enddo

   do BACDLIS2 with 7,25,16,63,e

   l=9
   cle=0

   set color to &CRIEN
   @24,0
   @24,1 say "^Home => Eff tout, ^End => Garde 1, "+ ;
             "BS => Eff., Del => Marque, Enter => Enlve"

   do while .T.

      do BACRLIST with 9,16,25,l,alphabet+" 28"+chr(7)+chr(22)+ ;
                       chr(8)+chr(9)+chr(29)+chr(23),cle

      set color to &BSBGP

      do case
         case cle=27
              exit

         case cle=29
              x=.F.
              do BACON with "Tout supprimer?",l+1,x
              if x
                 zap
                 pack
                 cle=27
                 exit
              endif

         case cle=9
              set color to &CRIEN
              ltys=L_TY->VAL
              @l,59 get L_TY->VAL picture "99" range 0,99
              do_read()
              if mod(readkey(),128)=12
                 replace L_TY->VAL with ltys
              endif
              set color to &BSBGP
              @l,59 say L_TY->VAL picture "99"

         case cle=23
              x=.F.
              do BACON with "N'en garder qu'un seul?",l+1,x
              if x
                 x=recno()
                 delete all
                 go x
                 recall
                 pack
                 exit
              endif

         case cle=8
              do DESTTYL with e
              exit

         case cle=50
              keyboard chr(7)+chr(24)

         case cle=56
              keyboard chr(7)+chr(5)

         case cle=13
              recall
              @l,29 say " "

         case cle=7
              delete
              @l,29 say ""

         case cle=22
              do INSTYL with e
              exit

         case cle=32
              mgrp=TYPES->TVISIT
              @l,52 get mgrp picture "@!"
              set color to &CRIEN
              do_read()
              Set Color To &BSBGP
              if mod(readkey(),128)=12
                 @l,52 say TYPES->TVISIT
                 loop
              endif
              e=recno()
              select 4
              set order to 2
              seek trim(mgrp)
              x=.not. found()
              ngr=TYPES->TYPE
              set order to 1
              select 13

              if x
                 do BACERR with "Ce type n'existe pas!",l+1
                 go e
                 Set Color To &BSBGP
                 @l,52 say TYPES->TVISIT
                 loop
              endif

              seek ngr
              if .not. found()
                 do BACERR with "Ce type n'est pas slectionn!",l+1
                 go e
                 Set Color To &BSBGP
                 @l,52 say TYPES->TVISIT
                 loop
              endif
              exit

         case chr(cle) $ alphabet
              keyboard " "+chr(25)+chr(cle)

         otherwise
              exit

      endcase

   enddo

   if cle=27
      exit
   endif

enddo

close all
select 1

return

*****************************************************************************
*
*                  I N S T Y L
*
*****************************************************************************

Procedure INSTYL

Parameter enr

mty=space(4)
mval=1
do savscr

do while .T.

   set color to &BSBGP
   @16,25,18,63 box "͵ "
   set color to &CRIEN
   @24,0
   @24,2 say "Esc => Fin"

   set color to &BSBGP
   @17,30 say "Code et valeur :"
   set color to &CRIEN
   @17,52 get mty picture "@!@K"
   @17,59 get mval picture "99" range 0,99
   do_read()
   if mod(readkey(),128)=12
      exit
   endif

   cle=0
   select 4
   set order to 2
   seek trim(mty)
   if TYPES->TCLAIR<>mty .or. .not. found()
      do savscr
      if .not. found()
         go top
      endif

      do while .T.

         e=recno()
         do BACDLIS1 with 14,48,22,74,space(7)+"Type"
         l=16
         do while l<22 .and. .not. eof()
            @l,49 say "    "+TYPES->TCLAIR
            l=l+1
            skip
         enddo
         do BACDLIS2 with 14,48,22,74,e
         cle=0
         set color to &CRIEN
         @24,0
         @24,2 say "Esc => Annuler, Enter => Valider"
         do BACRLIST with 16,22,48,16,chr(13),cle
         if cle=27 .or. cle=13
            exit
         endif

      enddo

      do rstscr
   endif

   ngr=TYPES->TYPE
   set order to 1
   select 13

   if cle=27
      cle=0
      loop
   endif

   seek ngr
   if found()
      do BACERR with "Ce type est dj slectionn!",18
      loop
   endif

   append blank
   replace L_TY->TY with ngr,L_TY->VAL with mval
   enr=recno()

   e=recno()
   do BACDLIS1 with 7,25,16,63,space(8)+"Type"+space(14)+"Code  Val."

   l=16
   e=recno()
   do while l>12 .and. .not. bof()
      l=l-1
      skip -1
   enddo

   l=9
   do while l<16 .and. .not. eof()
      @l,26 say "   "+iif(deleted(),""," ")+ ;
                TYPES->TCLAIR+"  "+TYPES->TVISIT+"  "+str(L_TY->VAL,2)
      if recno()=enr
         lenr=l
      endif
      l=l+1
      skip
   enddo

   do BACDLIS2 with 7,25,16,63,e
   set color to &RPSBGP
   @lenr,26 say "  "+TYPES->TCLAIR+"  "+TYPES->TVISIT+"  "+str(L_TY->VAL,2)

enddo

go enr
do rstscr

return

*****************************************************************************
*
*                  D E S T T Y L
*
*****************************************************************************

Procedure DESTTYL

Parameter enr

Private l,x,e

count for deleted() to x
go enr
if x=0
   do BACERR with "Pas de type marqu!",16
   return
endif

l=9
ldel=15
set color to &BGPSB
do while l<16 .and. .not. eof()
   if deleted()
      @l,27 say "   "+TYPES->TCLAIR+"  "+TYPES->TVISIT+"  "+ ;
                str(L_TY->VAL,2)+"  "
      ldel=l
   endif
   l=l+1
   skip
enddo

x=.T.
do BACON with "Confirmez la suppression.",ldel+1,x
if x
   pack
   go top
   if eof()
      keyboard chr(27)
   endif
endif

go top

return

*****************************************************************************
*
*                  F G R O U P E
*
*****************************************************************************

Procedure FGROUPE

select 11
use L_GP index I_GP
select 1
use GROUPES index NOGRP,GROUPE
select 11

HelpKey="FILTRES"
go top
if eof()
   x=.F.
   do BACON with "Tout est slectionn, visualiser?",8,x
   if .not. x
      close all
      return
   endif
   select 1
   set order to 2
   go top
   do while .not. eof()
      select 11
      append blank
      replace L_GP->GP with GROUPES->NOGRP
      select 1
      skip
   enddo
   set order to 1
endif

select 11
set relation to GP into GROUPES
set order to 0
go top

alphabet="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz"

do while .T.

   e=recno()
   set order to 0

   do BACDLIS1 with 8,25,16,71,space(8)+"Auteur"

   l=10

   do while l<16 .and. .not. eof()
      @l,26 say "   "+iif(deleted(),""," ")+ ;
                left(dsc_grp(GROUPES->GROUPE)+space(40),40)
      l=l+1
      skip
   enddo

   do BACDLIS2 with 8,25,16,71,e

   l=10
   cle=0

   set color to &CRIEN
   @24,0
   @24,1 say "^Home => Eff tout, ^End => Garde 1, "+ ;
             "BS => Eff., Del => Marque, Enter => Enlve"

   do while .T.
      set order to 0
      do BACRLIST with 10,16,25,l,alphabet+" 28"+chr(7)+ ;
                       chr(29)+chr(22)+chr(8)+chr(23),cle
      set order to 1
      set color to &BSBGP

      do case
         case cle=27
              exit

         case cle=29
              x=.F.
              do BACON with "Tout supprimer?",l+1,x
              if x
                 zap
                 pack
                 cle=27
                 exit
              endif

         case cle=23
              x=.F.
              do BACON with "N'en garder qu'un seul?",l+1,x
              if x
                 x=recno()
                 delete all
                 go x
                 recall
                 pack
                 exit
              endif

         case cle=8
              do DESTGP with e
              exit

         case cle=50
              keyboard chr(7)+chr(24)

         case cle=56
              keyboard chr(7)+chr(5)

         case cle=13
              recall
              @l,29 say " "

         case cle=7
              delete
              @l,29 say ""

         case cle=22
              do INSGP with e
              exit

         case cle=32
              mgrp=GROUPES->GROUPE
              @l,30 get mgrp picture "@!"
              set color to &CRIEN
              do_read()
              Set Color To &BSBGP
              if mod(readkey(),128)=12
                 @l,30 say GROUPES->GROUPE
                 loop
              endif
              e=recno()
              select 1
              set order to 2
              seek trim(left(mgrp,4))
              x=.not. found()
              ngr=GROUPES->NOGRP
              set order to 1
              select 11

              if x
                 do BACERR with "Cet auteur n'existe pas!",l+1
                 go e
                 Set Color To &BSBGP
                 @l,30 say GROUPES->GROUPE
                 loop
              endif

              seek ngr
              if .not. found()
                 do BACERR with "Cet auteur n'est pas slectionn!",l+1
                 go e
                 Set Color To &BSBGP
                 @l,30 say GROUPES->GROUPE
                 loop
              endif
              exit

         case chr(cle) $ alphabet
              keyboard " "+chr(25)+chr(cle)

         otherwise
              exit

      endcase

   enddo

   if cle=27
      exit
   endif

enddo

close all
select 1

return

*****************************************************************************
*
*                  I N S G P
*
*****************************************************************************

Procedure INSGP

Parameter enr

mgr=space(40)
do savscr

do while .T.

   set color to &BSBGP
   @16,25,18,71 box "͵ "
   set color to &CRIEN
   @24,0
   @24,2 say "Esc => Fin"

   @17,30 get mgr picture "@!@K"
   do_read()
   if mod(readkey(),128)=12
      exit
   endif

   cle=0
   select 1
   set order to 2
   seek trim(mgr)
   if GROUPES->GROUPE<>mgr .or. .not. found()
      do savscr
      if .not. found()
         go top
      endif

      do while .T.

         e=recno()
         do BACDLIS1 with 16,10,22,60,space(7)+"Auteur"
         l=18
         do while l<22 .and. .not. eof()
            @l,12 say "    "+left(dsc_grp(GROUPES->GROUPE)+space(40),40)
            l=l+1
            skip
         enddo
         do BACDLIS2 with 16,10,22,60,e
         cle=0
         set color to &CRIEN
         @24,0
         @24,2 say "Esc => Annuler, Enter => Valider"
         do BACRLIST with 18,22,10,18,chr(13),cle
         if cle=27 .or. cle=13
            exit
         endif

      enddo

      do rstscr
   endif

   ngr=GROUPES->NOGRP
   set order to 1
   select 11

   if cle=27
      cle=0
      loop
   endif

   seek ngr
   if found()
      do BACERR with "Cet auteur est dj slectionn!",18
      loop
   endif

   append blank
   replace L_GP->GP with ngr
   enr=recno()

   set order to 0
   do BACDLIS1 with 8,25,16,71,space(8)+"Auteur"

   go enr
   l=16
   do while l>12 .and. .not. bof()
      l=l-1
      skip -1
   enddo

   l=10
   do while l<16 .and. .not. eof()
      @l,26 say "   "+iif(deleted(),""," ")+ ;
                left(dsc_grp(GROUPES->GROUPE)+space(40),40)
      if recno()=enr
         lenr=l
      endif
      l=l+1
      skip
   enddo

   set order to 1
   do BACDLIS2 with 8,25,16,71,enr
   set color to &RPSBGP
   @lenr,26 say "  "+left(dsc_grp(GROUPES->GROUPE)+space(40),40)

enddo

go enr
do rstscr

return

*****************************************************************************
*
*                  D E S T G P
*
*****************************************************************************

Procedure DESTGP

Parameter enr

Private l,x

set order to 0
count for deleted() to x
go enr
if x=0
   do BACERR with "Pas d'auteur marqu!",16
   set order to 1
   return
endif

l=10
ldel=15
set color to &BGPSB
do while l<16 .and. .not. eof()
   if deleted()
      @l,27 say "   "+left(dsc_grp(GROUPES->GROUPE)+space(40),40)
      ldel=l
   endif
   l=l+1
   skip
enddo

x=.T.
do BACON with "Confirmez la suppression.",ldel+1,x
if x
   pack
   go top
   if eof()
      keyboard chr(27)
   endif
endif
go top
set order to 1

return

*****************************************************************************
*
*                  F A N N E E S
*
*****************************************************************************

Procedure FANNEES

do SAVSCR

Set Color to &BGPSB
@ 10,24 clear to 15,57
@ 10,24 to 15,57 double
FS1S=FANS1
FS2S=FANS2
FA1S=FANA1
FA2S=FANA2
PLAS=PLAGE

do while .T.

   Set Color To &BGPSB
   @11,26 say "Anne de sortie,    de" get FANS1 picture "99"
   @11,52 say "" get FANS2 picture "99"
   @12,26 say "Anne d'aquisition, de" get FANA1 picture "99"
   @12,52 say "" get FANA2 picture "99"
   @13,26 say "Titre de plage:"
   @14,25 say " " get PLAGE picture "!XXXXXXXXXXXXXXXXXXXXXXXXXXXX"
   set color to
   do_read()

   if mod(readkey(),128)=12
      FANS1=FS1S
      FANS2=FS2S
      FANA1=FA1S
      FANA2=FA2S
      PLAGE=PLAS
      exit
   endif

   if FANS2<FANS1 .or. FANA2<FANA1
      do BACERR with "Les annes doivent tre dans l'ordre.",13
   else
      exit
   endif

enddo

do RSTSCR

Return
