*****************************************************************************
*
*                  D S C 3
*
*****************************************************************************

Procedure DSC3

q300000=space(8)

do while .T.

   HelpKey="LISTES"
   fin=chr(4)+chr(19)
   do MN300000 with l300000,q300000,fin

   if q300000="********" .or. fin $ chr(4)+chr(19)
      exit
   endif

   do SAVSCR

   do case

      case q300000="LGLO    "
           do LISTE with 3,"TOUT"

      case q300000="LDIS    "
           do LISTE with 4,"DISQUES"

      case q300000="LGRO    "
           do LISTE with 5,"GROUPES"

      case q300000="LGRE    "
           do LGENRES

      case q300000="LTYP    "
           do LTYPES

      case q300000="CPT     "
           do COMPTE

   endcase

   do RSTSCR

enddo

return

****************************************************************************

procedure LISTE

Parameters ou_ca,quoi

Public filen,Detail,TriGenre,GRepere

Detail=.F.
do BACON with "Impression dtaille?",ou_ca,Detail

x=.T.
filen="OUTPUT  .TXT"

do while .T.

   do BACIMP with filen,ou_ca,x
   if x
      return
   endif

   if file(CurDir+filen) .and. filen<>"CON:" .and. filen<>"PRN:"
      x=.F.
      do BACON with "Le fichier "+CurDir+filen+ ;
                    " existe dj, l'craser?",ou_ca,x
      if .not. x
         loop
      endif
   endif

   exit
enddo

*If (filen="PRN:" .or. filen="CON:") .and.
if quoi<>"GROUPES"
   TriGenre=.F.
   do BACON with "Liste trie par genre",ou_ca,TriGenre
endif

do SAVSCR

do case

   case filen<>"CON:" .and. filen<>"PRN:"
        do BACPAT with "Ecriture du fichier "+filen+" en cours.",ou_ca
        set alternate to (CurDir+filen)

   case filen="PRN:"
        x=.T.
        do BACISP with ou_ca,x
        if x
           do RSTSCR
           return
        endif
        do BACPAT with "Impression en cours.",ou_ca

   otherwise
        do BACPAT with "Prparation de la liste en cours.",ou_ca

endcase

if filen="CON:"
   maxlig=22
else
   maxlig=MaxLigImp
   set console off
endif

fin=.F.
ok=.F.
lig=100
page=0
set color to &CRIEN

select 1
use GROUPES index GROUPE
if quoi="GROUPES" .or. TriGenre
   index on str(GROUPES->GENRE,3)+GROUPES->GROUPE to IGL.$$$
endif

if quoi<>"GROUPES"
   select  2
   use DISQUES
   set filter to DISQUES->ANSORTIE>=FANS1 .and. DISQUES->ANSORTIE<=FANS2 ;
           .and. DISQUES->ANACHAT>=FANA1 .and. DISQUES->ANACHAT<=FANA2

   go top
   if eof()
      fin=.T.
   endif

   if .not. eof()
      index on ;
         str(NOGROUP,3)+str(ANSORTIE,2)+str(ANACHAT,2)+DISQUE to IDL.$$$
   endif
endif

select 11
use L_GP
declare LGP [max(reccount(),1)]
use L_GR
declare LGR [max(reccount(),1)]
use L_TY
declare LTY [max(reccount(),1)]
declare LVAL [max(reccount(),1)]
use

do SetTab

select 5
use TITRES index ORTIT
if trim(PLAGE) <> ""
   set filter to ltrim(trim(PLAGE)) $ TITRE
endif
go top

select 4
use TYPES index TYPE
select 2
set relation to DISQUES->TYPE into TYPES

select 3
use GENRES index GENRE
select 1
set relation to GROUPES->GENRE into GENRES

go top

if filen="CON:" .and. .not. fin
   set color to &CRIEN
   do AGRFRM with ou_ca,25,ou_ca+3,55,0,0,22,79
   @0,0 clear to 22,79
endif
lmp=1
if filen="PRN:" .and. .not. fin
   set print on
endif
if filen<>"PRN:" .and. filen<>"CON:" .and. .not. fin
   set alternate on
endif
dj=.F.

if fin
   do BACERR with ;
      "Aucun lment ne rpond au(x) critre(s) demand(s)",ou_ca
endif
GRepere=-1

do while .not. eof() .and. .not. fin

   if IF_GENRE(GROUPES->GENRE) .and. IF_GROUP(GROUPES->NOGRP)
      MLC=MLCount(GROUPES->MEMOG,67)
      MLD=.F.
      if Detail .and. lmp<=MLC
         if lig>maxlig-2-iif(quoi="GROUPES",1,4) .and. maxlig>0
            do ENTETE with page,lig,fin
            if fin
               exit
            endif
            if quoi="GROUPES" .or. TriGenre
               do GENRECL
            endif
         endif
         if (quoi="GROUPES" .or. TriGenre) .and. ;
            GROUPES->GENRE<>GRepere .and. lig+6<maxlig
            do GENRECL
         endif
         if quoi<>"GROUPES"
            do TITRE_GP with GROUPES->GROUPE,lig
         else
            ? space(iif(MaxLig=0,0,6))+trim(dsc_grp(GROUPES->GROUPE))
            lig=lig+1
         endif
         lig=lig+1
         if MaxLig <> 0
            ? space(8)+""+replicate("",69)+""
         endif
         MLD=.T.
      endif
      if MaxLig = 0
         ? GROUPES->MEMOG
      else
         do while lig<MaxLig .and. MaxLig<>0 .and. Detail .and. lmp<=MLC
            ? space(8)+" "+MemoLine(GROUPES->MEMOG,67,lmp)+" "
            lig=lig+1
            lmp=lmp+1
         enddo
      endif
      if MLD
         lig=lig+1
         if MaxLig <> 0
            ? space(8)+""+replicate("",69)+""
         endif
         dj=.T.
      endif
      if MLC>=lmp .and. Detail .and. MaxLig > 0
         lig=100
         dj=.F.
         loop
      else
         lmp=1
         if quoi<>"GROUPES"
            do LIST_GRP with fin,lig,maxlig,quoi,(MLC<>0 .and. detail)
         else
            if MLC=0
               do EDT_GP with fin,lig,maxlig
            endif
         endif
      endif
   endif
   select 1
   skip

enddo

if filen<>"CON:"
   if filen="PRN:"
      set print on
   else
      set alternate on
   endif

   ? chr(12)
   set alternate off
   set print off
endif

if filen<>"CON:" .and. .not. fin
   ? chr(12)
endif

close databases
close alternate
set console on

if filen="CON:" .and. .not. fin
   do SETSWP
   @24,0
   @24,10 say "Fin de liste, tapez la barre d'espace ..."
   do G_KEY with " "+chr(27),.F.
endif

if filen="CON:"
   set color to &CRIEN
   @0,0 clear to 22,79
   do AGRFRM with 0,0,22,79,ou_ca-1,44,ou_ca-1,62
endif

do RSTSCR
delete file (CurDir+"IDL.$$$")
delete file (CurDir+"IGL.$$$")

return

*************************************************************

Function IF_GENRE

parameter g

return iif(LGR[1]=-1,.T.,(ascan(LGR,g)>0))

*************************************************************

Function IF_GROUP

parameters g

return iif(LGP[1]=-1,.T.,(ascan(LGP,g)>0))

**************************************************************

procedure LIST_GRP

parameters fin,lig,maxlig,quoi,deja

select 2
set exact off
go top
seek str(GROUPES->NOGRP,3)
lm=1

do while (.not. eof()) .and. DISQUES->NOGROUP=GROUPES->NOGRP .and. .not. fin

   if lig>maxlig-iif(Detail,4,0)-iif(quoi="TOUT",2,0) .and. maxlig>0
      do ENTETE with page,lig,fin
      if fin
         return
      endif
      if TriGenre
         do GENRECL
      endif
      deja=.F.
   endif

   if TriGenre .and. GROUPES->GENRE<>GRepere .and. ;
                     ( lig+6<maxlig .or. maxlig = 0 )
      do GENRECL
   endif

   xx=.T.
   if trim(PLAGE) <> ""
      select 5
      set exact off
      go top
      seek str(GROUPES->NOGRP,3)+str(DISQUES->NODSC,3)
      xx=.not. eof()
   endif

   if IF_TYPE(DISQUES->TYPE) >= 0 .and. xx
      select 2
      if .not. deja

         if lig+5>maxlig .and. maxlig>0

            do ENTETE with page,lig,fin

            if fin
               return
            endif && fin

            if TriGenre
               do GENRECL
            endif

         endif && lig+5>maxlig

         do TITRE_GP with GROUPES->GROUPE,lig
         deja=.T.

      endif && .not. deja

      ? space(iif(MaxLig=0,0,9))+iif(MaxLig=0,chr(9),"")+ ;
        str(DISQUES->ANSORTIE,2)+","+str(DISQUES->ANACHAT,2)+"  "+;
        iif(MaxLig<>0,DISQUES->DISQUE+" ",trim(DISQUES->DISQUE)+chr(9))+ ;
        trim(TYPES->TCLAIR)
      lig=lig+1
      MLC=MLCount(DISQUES->MEMO,57)
      MLD=.F.
      if Detail .and. lm<=MLC
         lig=lig+1
         if MaxLig <> 0
            ? space(18)+""+replicate("",59)+""
         endif
         MLD=.T.
      endif
      if MaxLig = 0
         ? DISQUES->MEMO
      else
         do while lig<MaxLig .and. Detail .and. lm<=MLC
            ? space(18)+" "+MemoLine(DISQUES->MEMO,57,lm)+" "
            lig=lig+1
            lm=lm+1
         enddo
      endif
      if MLD
         lig=lig+1
         if MaxLig <> 0
            ? space(18)+""+replicate("",59)+""
         endif
      endif
      if MLC>=lm .and. Detail .and. MaxLig > 0
         deja=.F.
         lig=100
         loop
      else
         lm=1
         if quoi="TOUT" .and. (lig+5<=maxlig .or. maxlig=0)
            isal=.F.
            do LISTIT with fin,lig,maxlig,isal
            if isal .and. lig<maxlig
               ?
               lig=lig+1
            endif
         endif
      endif

   endif

   select 2
   skip

enddo && .not. eof()

return

**************************************************************

procedure LISTIT

parameter fin,lig,maxlig,isal

select 5
set exact off
go top
seek str(GROUPES->NOGRP,3)+str(DISQUES->NODSC,3)
lmt=1
dejat=.T.

do while (.not. eof()) .and. TITRES->TGP=GROUPES->NOGRP .and. ;
                             TITRES->TDS=DISQUES->NODSC .and. .not. fin

   isal=.T.
   if lig>maxlig-iif(Detail,3,0) .and. maxlig>0
      do ENTETE with page,lig,fin
      if fin
         return
      endif
      dejat=.F.
   endif

   if .not. dejat

      if lig+5>maxlig .and. maxlig>0

         do ENTETE with page,lig,fin

         if fin
            return
         endif && fin

      endif && lig+5>maxlig

      do TITRE_GP with GROUPES->GROUPE,lig
      ? space(iif(MaxLig=0,0,9))+iif(MaxLig=0,chr(9),"")+ ;
        str(DISQUES->ANSORTIE,2)+","+str(DISQUES->ANACHAT,2)+"  "+;
        iif(MaxLig<>0,DISQUES->DISQUE+" ",trim(DISQUES->DISQUE)+chr(9))+ ;
        trim(TYPES->TCLAIR)
      lig=lig+1
      dejat=.T.

   endif && .not. dejat

   ? space(iif(MaxLig=0,0,16))+"- "+ ;
     iif(MaxLig=0,trim(TITRES->TITRE),TITRES->TITRE)+ ;
     iif(MaxLig=0,chr(9),"   ")+trim(TITRES->DURE)
   lig=lig+1
   MLC=MLCount(TITRES->MEMOT,57)
   MLD=.F.
   if Detail .and. lmt<=MLC
      lig=lig+1
      if MaxLig <> 0
         ? space(18)+""+replicate("",59)+""
      endif
      MLD=.T.
   endif
   if MaxLig = 0
      ? TITRES->MEMOT
   else
      do while lig<MaxLig .and. MaxLig<>0 .and. Detail .and. lmt<=MLC
         ? space(18)+" "+MemoLine(TITRES->MEMOT,57,lmt)+" "
         lig=lig+1
         lmt=lmt+1
      enddo
   endif
   if MLD
      lig=lig+1
      if MaxLig <> 0
         ? space(18)+""+replicate("",59)+""
      endif
   endif
   if MLC>=lmt .and. Detail .and. MaxLig > 0
      dejat=.F.
      lig=100
      loop
   else
      lmt=1
   endif

   select 5
   skip

enddo && .not. eof()

return

******************************************************

Function IF_TYPE

parameter t

if LTY[1]=-1
   return 1
endif

a=ascan(LTY,t)

return iif(a>0,LVAL[a],-1)

********************************************************

procedure TITRE_GP

parameters q,l

?
? space(iif(MaxLig=0,0,6))+trim(dsc_grp(q))
if MaxLig > 0
   ? space(6)+replicate ("",len(trim(dsc_grp(q))))
   ?
endif
l=l+4

return

********************************************************

procedure ENTETE

parameters pg,lg,fin

if filen<>"CON:"

   if pg>0
      ? chr(12) && eject
   endif
   fin=(inkey()=27)

else

   if pg<>0

      do SETSWP
      @24,0
      @24,10 say "Tapez la barre d'espace pour continuer, [Esc] pour arrter."

      cle=0
      do G_KEY with " "+chr(27),cle,.F.
      set color to &CRIEN
      @24,0
      @24,10 say "Affichage en cours ..."
      fin=(cle=27)

      if fin
         return
      endif && fin

   endif && pg<>0

   @0,0 clear to 22,79

endif

pg=pg+1

if filen<>"CON:"
   ? space(1)+cdowf(date())+", "+str(day(date()),2)+" "+cmonthf(date())+ ;
     " "+str(year(date()),4)+space(30)+"<page "+str(pg,3)+">"
   ?
   ?
   lg=3
else
   @0,0 say space (65)+"<page "+str(pg,3)+">"
   lg=1
endif

return

****************************************************************************

procedure EDT_GP

parameter fin,lig,maxlig

if filen="PRN:"
   set print on
endif
if filen<>"PRN:" .and. filen<>"CON:"
   set alternate on
endif

if lig>maxlig .and. maxlig>0
   do ENTETE with page,lig,fin
   do GENRECL
endif

if GROUPES->GENRE <> GRepere .and. ( lig+4<maxlig .or. maxlig = 0)
   do GENRECL
endif
? space(iif(MaxLig=0,0,6))+trim(dsc_grp(GROUPES->GROUPE))
lig=lig+1

set print off
set alternate off

return

***************************************************

procedure COMPTE

HelpKey="COMPTES"
do SAVSCR
set color to &BGPSB
@10,46 to 17,66 double
@11,47 clear to 16,65
@11,48 say "Auteurs : 0000"
@12,48 say "Disques : 0000"
@13,48 say "Nbr Max : 0000"
@14,48 say "Nbr Min : 0000"
@15,48 say "Moyenne : 0000.00"
@16,48 say "Ec type : 0000.00"

gn=0
dn=0
fin=.F.
sx2=0
smax=0
smin=9999

use L_GP
declare LGP [max(reccount(),1)]
use L_GR
declare LGR [max(reccount(),1)]
use L_TY
declare LTY [max(reccount(),1)]
declare LVAL [max(reccount(),1)]
use

do SetTab

select 1
use GROUPES
select 2
use DISQUES
set filter to DISQUES->ANSORTIE>=FANS1 .and. DISQUES->ANSORTIE<=FANS2 ;
           .and. DISQUES->ANACHAT>=FANA1 .and. DISQUES->ANACHAT<=FANS2
index on DISQUES->NOGROUP to I_DX.$$$

go top
if eof()
   fin=.T.
endif

select 1

if fin
   go bottom
   fin=.F.
endif

do while .not. eof() .and. .not. fin

   if IF_GENRE(GROUPES->GENRE) .and. IF_GROUP(GROUPES->NOGRP)
      gn=gn+1
      @11,58 say str(gn,4)
      dx=0
      do D_COMPT with dn,dx,GROUPES->NOGRP,fin
      sx2=sx2+(dx*dx)
      smax=max(smax,dx)
      smin=min(smin,dx)
      @13,58 say str(smax,4)
      @14,58 say str(smin,4)
      @15,58 say str(dn/iif(gn<>0,gn,1),7,2)
      @16,58 say str(sx2/iif(dn<>0,dn*dn,1),7,2)
   endif

   if inkey()=27
      fin=.T.
   endif

   select 1
   skip

enddo

close databases
clear typeahead

delete file (CurDir+"I_DX.$$$")

if fin
   do RSTSCR
   return
endif

do BACAFF with "Dcompte termin.",17
do RSTSCR

return

*********************************************************

procedure D_COMPT

parameters dn,dnx,ngp,fin

select 2
seek GROUPES->NOGRP

do while .not. eof() .and. DISQUES->NOGROUP=GROUPES->NOGRP

   x=IF_TYPE(DISQUES->TYPE)
   if x>0
      dn=dn+x
      dnx=dnx+x
   endif
   select 2

   @12,58 say str(dn,4)

   if inkey()=27
      fin=.T.
      exit
   endif

   skip

enddo

return

****************************************************************************

procedure LGENRES

Public filen

x=.T.
filen="OUTPUT  .TXT"

do while .T.

   do BACIMP with filen,6,x
   if x
      return
   endif

   if file(CurDir+filen) .and. filen<>"CON:" .and. filen<>"PRN:"
      x=.F.
      do BACON with "Le fichier "+CurDir+filen+" existe dj, l'craser?",6,x
      if .not. x
         loop
      endif
   endif

   exit
enddo

do SAVSCR

do case

   case filen<>"CON:" .and. filen<>"PRN:"
        do BACPAT with "Ecriture du fichier "+filen+" en cours.",6
        set alternate to (CurDir+filen)
        set alternate on

   case filen="PRN:"
        x=.T.
        do BACISP with 6,x
        if x
           do RSTSCR
           return
        endif
        do BACPAT with "Impression en cours.",6
        set print on

   case filen="CON:"
        set color to &CRIEN
        do AGRFRM with 5,44,5,62,0,0,22,79
        @0,0 clear to 22,79

endcase

if filen="CON:"
   maxlig=22
else
   maxlig=MaxLigImp
   set console off
endif

fin=.F.
lig=100
page=0
set color to &CRIEN

select 3
use GENRES index GCLAIR
go top

do while .not. eof() .and. .not. fin

   if lig>maxlig .and. maxlig>0
      do ENTETE with page,lig,fin
   endif

   ? space(iif(MaxLig=0,0,6))+trim(GENRES->GCLAIR)
   lig=lig+1

   skip

enddo

if filen<>"CON:" .and. .not. fin
   ? chr(12)
endif

close databases
close alternate
set printer off
set console on

if filen="CON:" .and. .not. fin
   do SETSWP
   @24,0
   @24,10 say "Fin de liste, tapez la barre d'espace ..."
   do G_KEY with " "+chr(27),.F.
endif

if filen="CON:"
   set color to &CRIEN
   @0,0 clear to 22,79
   do AGRFRM with 0,0,22,79,5,44,5,62
endif

do RSTSCR

return

*****************************************************************************

procedure LTYPES

Public filen

x=.T.
filen="OUTPUT  .TXT"

do while .T.

   do BACIMP with filen,7,x
   if x
      return
   endif

   if file(CurDir+filen) .and. trim(filen)<>"CON:" .and. trim(filen)<>"PRN:"
      x=.F.
      do BACON with "Le fichier "+CurDir+filen+" existe dj, l'craser?",7,x
      if .not. x
         loop
      endif
   endif

   exit
enddo

do SAVSCR

do case

   case filen<>"CON:" .and. filen<>"PRN:"
        do BACPAT with "Ecriture du fichier "+filen+" en cours.",7
        set alternate to (CurDir+filen)
        set alternate on

   case filen="PRN:"
        x=.T.
        do BACISP with 6,x
        if x
           do RSTSCR
           return
        endif
        do BACPAT with "Impression en cours.",7
        set print on

   case filen="CON:"
        set color to &CRIEN
        do AGRFRM with 6,44,6,62,0,0,22,79
        @0,0 clear to 22,79


endcase

if filen="CON:"
   maxlig=22
else
   maxlig=MaxLigImp
   set console off
endif

fin=.F.
lig=100
page=0
set color to &CRIEN

select 4
use TYPES index TVISIT
go top

do while .not. eof() .and. .not. fin

   if lig>maxlig .and. maxlig>0
      do ENTETE with page,lig,fin
   endif

   ? space(iif(MaxLig=0,0,6))+TYPES->TCLAIR+space(10)+TYPES->TVISIT
   lig=lig+1

   skip

enddo

if filen<>"CON:" .and. .not. fin
   ? chr(12)
endif

close databases
close alternate
set printer off
set console on

if filen="CON:" .and. .not. fin
   do SETSWP
   @24,0
   @24,10 say "Fin de liste, tapez la barre d'espace ..."
   do G_KEY with " "+chr(27),.F.
endif

if filen="CON:"
   set color to &CRIEN
   @0,0 clear to 22,79
   do AGRFRM with 0,0,22,79,6,44,6,62
endif

do RSTSCR

return

*****************************************************************************

Procedure SetTab

select 11
use L_GP
if eof()
   LGP[1]=-1
else
   for a=1 to reccount()
       LGP[a]=L_GP->GP
       skip
   next
endif
use

select 12
use L_GR
if eof()
   LGR[1]=-1
else
   for a=1 to reccount()
       LGR[a]=L_GR->GR
       skip
   next
endif
use

select 13
use L_TY
if eof()
   LTY[1]=-1
else
   for a=1 to reccount()
       LTY[a]=L_TY->TY
       LVAL[a]=L_TY->VAL
       skip
   next
endif
use

return

*****************************************************************************

Procedure GENRECL

xgcl=trim(GENRES->GCLAIR)
?
? space(iif(MaxLig=0,0,6))+ ;
  iif(Maxlig=0,"",left(space(40),(80-len(xgcl))/2))+ ;
  trim(GENRES->GCLAIR)
if MaxLig > 0
   ? space(6)+left(space(40),(80-len(xgcl))/2)+ ;
        replicate(chr(205),len(xgcl))
endif
?
lig=lig+4
GRepere=GROUPES->GENRE

return
