set pagesize 500

column cle      format a20
column dte      format a6
column slbtrg   format 999999.99
column hbbtrg   format 999999.99
column neg      format 999999.99

break on report

compute sum of slbtrg   on report
compute sum of hbbtrg   on report
compute sum of neg      on report

spool gcverif

select to_char(bcnprtgsf,   '09')||to_char(bcnprtjhr,'99')||
       to_char(bcnprtnmr,'00009')||to_char(bcnnmr, '0009') cle,
       to_char(bcndtm,'DDMMYY') dte, bcncde, ggknmr,
       nvl(slbtrg,0)+nvl(hbbtrg,0) neg, slbtrg, hbbtrg
from   grc_bcn
where  slbtrg < 0 or hbbtrg < 0
order  by bcnprtgsf, bcnprtjhr, bcnprtnmr, bcnnmr;

spool off
