Program GetDTyp;

Uses Dos;

Const MaxStr = 255;

Type DriveCar = Record
                SectorsPerCluster : Byte;
                BytesPerSector    : Integer;
                Clusters          : Integer;
                End { Record };

Var DriveToTest : DriveCar;
    DriveLetter : Char;
    DriveString : String [MaxStr];

{-----------------------------------------------------------------------------}

Procedure GetDriveInfos (    DriveIdentifier : Byte;
                         Var DriveCaract     : DriveCar);

Var

   Regs       : Registers;

Begin

   With Regs Do
   Begin
     AH := $1C;
     DL := DriveIdentifier;
     Intr ($21,Regs);
     DriveCaract.SectorsPerCluster := AL;
     DriveCaract.BytesPerSector    := CX;
     DriveCaract.Clusters          := DX;
   End; { With }

End;   { GetDriveInfos }

{-----------------------------------------------------------------------------}

Begin

  DriveString := Copy (ParamStr(1),1,1);
  If ParamCount < 1
     Then DriveLetter := '@'
     Else DriveLetter := UpCase (DriveString [1]);

  WriteLn (DriveLetter, ' ', Ord (DriveLetter)-64);

  GetDriveInfos (Ord (DriveLetter)-64, DriveToTest);

  WriteLn (DriveToTest.SectorsPerCluster:10,
           DriveToTest.BytesPerSector:10,
           DriveToTest.Clusters:10);

End.