Program GetDTyp;

Type DriveCar = Record
                SectorsPerCluster : Byte;
                BytesPerSector    : Integer;
                Clusters          : Integer;
                End { Record };

Var DriveToTest : DriveCar;

{-----------------------------------------------------------------------------}

Procedure GetDriveInfos (    DriveIdentifier : Byte;
                         Var DriveCaract     : DriveCar);

Var

   Regs       : Registers;

Begin

   With Regs Do
   Begin
     AH := $1C; Intr ($21,Regs);
     DL := DriveIdentifier;
     DriveCaract.SectorsPerCluster := AL;
     DriveCaract.BytesPerSector    := CX;
     DriveCaract.Clusters          := DX;
   End; { With }

End;   { GetDriveInfos }

{-----------------------------------------------------------------------------}

Begin

  GetDriveInfos (1, DriveToTest);

  WriteLn (DriveToTest.SectorsPerCluster:10,
           DriveToTest.BytesPerSector:10,
           DriveToTest.Clusters:10);

End.