
program BeziDemo;

{$I typedef.sys}                       {ces fichers doivent tre inclus}
{$I graphix.sys}                       {et dans cet ordre}
{$I kernel.sys}
{$I windows.sys}
{$I axis.hgh}
{$I polygon.hgh}
{$I bezier.hgh}


procedure ClearToEol;                  {efface jusqu' la fin de ligne}
var i: integer;

begin
  for i:=1 to 80 do write(' ');
end;



procedure BezierDem;

var result,i,MaxControlPoints,MaxIntPoints:integer;
    dummyx,dummyy:real;
    a,b:PlotArray;
    break:boolean;
    DummyS,Temp2,Temp:wrkstring;

begin

  MaxControlPoints:=7;                 (* initialisation gnrale *)
  MaxIntPoints:=15;
  a[1,1]:=1;a[2,1]:=1.5;a[3,1]:=2;a[4,1]:=2.5;a[5,1]:=3;a[6,1]:=4;a[7,1]:=5;
  a[1,2]:=2;a[2,2]:=1.5;a[3,2]:=1;a[4,2]:=2.5;a[5,2]:=4;a[6,2]:=4.5;a[7,2]:=5;

  ClearScreen;                         { initialise l'cran }
  SetColorWhite;
  DefineWorld(1,0,7.0,6.33,0);
  SelectWorld(1);
  DefineWindow(1,0,0,XMaxGlb,17*YMaxGlb div 20);
  SelectWindow(1);
  SetBackground(0);
  DrawBorder;
  DrawAxis(7,-7,0,0,0,0,0,0,false);

  break:=false;                        {initialise le drapeau d'arrt }

  repeat
    SetLinestyle(1);                   {trace le pplygne entre les points }
    DrawAxis(0,0,0,0,0,0,0,0,false);
    DrawPolygon(a,1,MaxControlPoints,4,2,0);

    bezier(a,MaxControlPoints,b,MaxIntPoints);  {calcule les points}

    SetLinestyle(0);                   {dessine la courbe}
    DrawAxis(0,0,0,0,0,0,0,0,false);
    DrawPolygon(b,1,MaxIntPoints,0,0,0);

    repeat
      gotoxy(1,24);                    {efface l'ancien texte}
      ClearToEol;
      gotoxy(1,25);
      ClearToEol;
      gotoxy(1,23);
      ClearToEol;
      gotoxy(1,23);                    {demander le point  changer}
      write('Entrez le numro du point  changer :  ');
      gotoxy(43,23);
      read(Temp);
      val(Temp,i,result);
    until i in [0..MaxControlPoints];

    if i>0 then
      begin
        repeat
          gotoxy(1,24);                {demander les nouvelles valeurs x,y}
          write('Ancienne position : [',a[i,1]:4:2,',',a[i,2]:4:2,']');
          gotoxy(40,24);write(' Nouvelle valeur de x:  ');
          gotoxy(62,24);
          read(DummyS);
          while DummyS[1]=' ' do delete(DummyS,1,1);
          Temp:=DummyS;
          gotoxy(40,25);write(' Nouvelle valeur de y:  ');
          gotoxy(62,25);
          read(DummyS);
          while DummyS[1]=' ' do delete(DummyS,1,1);
          Temp2:=DummyS;val(Temp,dummyx,result);val(Temp2,dummyy,result);
        until ((dummyx>=X1WldGlb) and (dummyx<=X2WldGlb)) and ((dummyy>=Y1WldGlb) and (dummyy<=Y2WldGlb));

        SetLinestyle(1);               {effacer l'ancienne courbe}
        SetColorBlack;
        DrawAxis(0,0,0,0,0,0,0,0,false);
        DrawPolygon(a,1,MaxControlPoints,4,2,0);
        SetLinestyle(0);
        DrawAxis(0,0,0,0,0,0,0,0,false);
        DrawPolygon(b,1,MaxIntPoints,0,0,0);
        a[i,1]:=dummyx;a[i,2]:=dummyy;
        SetColorWhite;
      end
    else break:=true;                  {est-ce fait?}
  until break;
end;



begin

InitGraphic;                           {initialiser le systme graphique }

BezierDem;                             {faire la dmonstration}

LeaveGraphic;                          {quitter le systme graphique}

end.

