
program OnePolygon;

{$I typedef.sys}                         {ces fichiers doivent tre}
{$I graphix.sys}                         {inclus et dans cet ordre}
{$I kernel.sys}
{$I windows.sys}
{$I polygon.hgh}


procedure PolygonDem;
var n:integer;
    b,a:PlotArray;
    ch:char;
    x1,x2:integer;

procedure GenerateFunction(var a,b:PlotArray;n:integer);

var i:integer;                           {genre une courbe sinusodale}
    delta:real;

begin
  delta:=2*pi/(n-1);
  for i:=1 to n do
    begin
      a[i,1]:=(i-1)*delta-pi;
      a[i,2]:=sin(a[i,1]);
    end;
end;


begin
  ClearScreen;

  n:=30;
  GenerateFunction(a,b,n);               {genre le polygone}

  DefineWindow(1,0,0,XMaxGlb,YMaxGlb);
  DefineHeader(1,'COURBE SINUSOIDALE');
  DefineWorld(1,-pi,1,pi,-1);
  SelectWorld(1);
  SelectWindow(1);
  SetBackground(0);
  SetHeaderOn;
  DrawBorder;

  DrawPolygon(a,1,n,0,0,0);              {trace le polygone}

end;



begin

InitGraphic;                             {initialiser le systme graphique}

PolygonDem;                              {dmonstration }

repeat until keypressed;                 {attendre qu'une touche soit tape }

LeaveGraphic;                            {quitter le systme graphique }

end.
