
program ScreenIO;

{$I typedef.sys}                       {ces fichiers doivent tre }
{$I graphix.sys}                       {chargs dans cet ordre}
{$I kernel.sys}


procedure Sierpinski;
const n=5;
var i,h,x,y,x0,y0:integer;
    sec:boolean;

procedure plot;                        {trace une ligne}
begin
  DrawLine(x,y,x0,y0);
  x0:=x;
  y0:=y;
end;


procedure b(i:integer); forward;       {rfrences forward pour la rcursion}

procedure c(i:integer); forward;

procedure d(i:integer); forward;

procedure a(i:integer);                { 1re procdure rcursive}
begin
  if i>0 then
  begin
    a(i-1);
    x:=x+h;
    y:=y-h;
    plot;
    b(i-1);
    x:=x+2*h;
    plot;
    d(i-1);
    x:=x+h;
    y:=y+h;
    plot;
    a(i-1);
  end;
end;

procedure b;                           { 2ime procdure rcursive}
begin
  if i>0 then
  begin
    b(i-1);
    x:=x-h;
    y:=y-h;
    plot;
    c(i-1);
    y:=y-2*h;
    plot;
    a(i-1);
    x:=x+h;
    y:=y-h;
    plot;
    b(i-1);
  end;
end;

procedure c;                           { 3ime }
begin
  if i>0 then
  begin
    c(i-1);
    x:=x-h;
    y:=y+h;
    plot;
    d(i-1);
    x:=x-2*h;
    plot;
    b(i-1);
    x:=x-h;
    y:=y-h;
    plot;
    c(i-1);
  end;
end;

procedure d;                           { dernire procdure rcursive}
begin
  if i>0 then
  begin
    d(i-1);
    x:=x+h;
    y:=y+h;
    plot;
    a(i-1);
    y:=y+2*h;
    plot;
    c(i-1);
    x:=x-h;
    y:=y+h;
    plot;
    d(i-1);
  end;
end;

procedure DoIt;                        {procdure principale sierpinski }
begin
  i:=3;
  h:=16;
  x0:=30;
  y0:=240;
  repeat
    i:=i+1;
    x0:=x0-h;
    h:=h div 2;
    y0:=y0+h;
    x:=x0;
    y:=y0;
    a(i-1);
    x:=x+h;
    y:=y-h;
    plot;
    b(i-1);
    x:=x-h;
    y:=y-h;
    plot;
    c(i-1);
    x:=x-h;
    y:=y+h;
    plot;
    d(i-1);
    x:=x+h;
    y:=y+h;
    plot;
  until i=n;
end;

begin   {sierpinski}
  SetHeaderOn;
  DefineWorld(1,-3,258,258,-3);
  SelectWorld(1);
  SelectWindow(1);
  DrawBorder;
  DoIt;

end;


begin

InitGraphic;                           {initialiser le systme graphique}

DefineHeader(1,'SAUVEGARDE ET RELECTURE DE/VERS LE DISQUE');

SetHeaderOn;                           {afficher l'en-tte}

Sierpinski;                            {tracer la courbe}


SaveScreen('DEMO.PIC');                {sauvegarder sur disque}

ClearScreen;                           {effacer l'cran}

Delay(1000);                      {delai pour que les utilisateurs de disques
                                   durs ou RAM-disques puissent voir l'action}

LoadScreen('DEMO.PIC');                {relire depuis le disque }


repeat until keypressed;               {attendre la frappe d'une touche}

LeaveGraphic;                          {quitter le systme graphique}

end.

