echo off
rem Display of all SETUP settings
rem
echo SETUP information PC-3000/3100

:M0
rem Low Power mode
SETUP /O0
IF ERRORLEVEL 1 GOTO LPON
IF ERRORLEVEL 0 GOTO LPOFF
ECHO Error in Low Power Mode setting
GOTO M1
:LPON
ECHO Low Power Mode is ON
GOTO M1
:LPOFF
ECHO Low Power Mode is OFF

rem Power down delay
:M1
SETUP /O1
IF ERRORLEVEL 5 GOTO PD5
IF ERRORLEVEL 2 GOTO PD2
IF ERRORLEVEL 1 GOTO PD1
IF ERRORLEVEL 0 GOTO PD0
echo Error in Power down delay setting
GOTO M2
:PD0
Echo Power down delay is OFF
goto M2

:PD1
Echo Power down delay is 1 Minute
goto M2

:PD2
Echo Power down delay is 2 Minutes
goto M2

:PD5
Echo Power down delay is 5 Minutes
goto M2

rem Keyclick
:M2
SETUP /O2
IF ERRORLEVEL 1 GOTO KC1
IF ERRORLEVEL 0 GOTO KC0
echo Error in Keyclick setting
GOTO M3
:KC0
echo Keyklick is OFF
GOTO M3
:KC1
echo Keyklick is ON
GOTO M3

rem All sounds
:M3
SETUP /O3
IF ERRORLEVEL 1 GOTO AS1
IF ERRORLEVEL 0 GOTO AS0
echo Error in All sounds setting
GOTO M4
:AS0
ECHO All sounds are OFF
GOTO M4
:AS1
ECHO All sounds are ON
GOTO M4

rem mode
:M4
SETUP /O4
IF ERRORLEVEL 7 GOTO SM7
IF ERRORLEVEL 3 GOTO SM3
IF ERRORLEVEL 1 GOTO SM1
echo The screen mode is set to other than recommended
GOTO M5
:SM7
echo Screen mode is 7
goto m5
:SM3
echo Screen mode is 3
goto m5
:SM1
echo Screen mode is 1
GOTO m5

rem CPU speed
:m5
SETUP /O5
IF ERRORLEVEL 10 GOTO cpu10
IF ERRORLEVEL 5 GOTO cpu5
if errorlevel 1 goto cpu1
echo Error in CPU speed setting
GOTO m6
:cpu1
echo CPU speed is 1 MHz
goto m6
:cpu5
echo CPU speed is 5 MHz
goto m6
:cpu10
echo CPU speed is 10 MHz
GOTO m6

rem Character set
:m6
SETUP /O6
IF ERRORLEVEL 1 GOTO cs1
IF ERRORLEVEL 0 GOTO cs0
echo Error in character setting
GOTO m7
:cs1
echo The character set is default
goto m7
:cs0
echo The character set is Scandinavian
GOTO m7

rem RS232 Baud rate
:m7
echo The settings of the RS232 are
SETUP /O7
IF ERRORLEVEL 7 GOTO rsb7
IF ERRORLEVEL 6 GOTO rsb6
IF ERRORLEVEL 5 GOTO rsb5
IF ERRORLEVEL 4 GOTO rsb4
IF ERRORLEVEL 3 GOTO rsb3
IF ERRORLEVEL 2 GOTO rsb2
IF ERRORLEVEL 1 GOTO rsb1
IF ERRORLEVEL 0 GOTO rsb0
echo Error in Baud rate setting
goto m8

:RSB7
echo Baud rate is 9600
GOTO m8
:RSB6
echo Baud rate is 4800
GOTO m8
:RSB5
echo Baud rate is 2400
GOTO m8
:RSB4
echo Baud rate is 1200
GOTO m8
:RSB3
echo Baud rate is 600
GOTO m8
:RSB2
echo Baud rate is 300
GOTO m8
:RSB1
echo Baud rate is 150
GOTO m8
:RSB0
echo Baud rate is 110
GOTO m8

rem DATA BITS of RS232
:m8
SETUP /O8
IF ERRORLEVEL 8 GOTO rsd8
IF ERRORLEVEL 7 GOTO rsd7
echo Error data bits setting
GOTO m9
:rsd7
echo 7 Data Bit
goto m9
:rsd8
echo 8 Data Bit
goto m9

rem Stop Bits of RS232
:m9
SETUP /O9
IF ERRORLEVEL 2 GOTO rss2
IF ERRORLEVEL 1 GOTO rss1
echo Error in Stop Bit setting
GOTO m10
:rss2
echo 2 Stop Bits
goto m10
:rss1
echo 1 Stop Bit
goto m10

rem Parity Bit of RS232
:m10
SETUP /O10
IF ERRORLEVEL 3 GOTO rsp3
IF ERRORLEVEL 1 GOTO rsp1
IF ERRORLEVEL 0 GOTO rsp0
echo Error in Parity Bit setting
GOTO exit
:rsp3
echo Even Parity
goto exit
:rsp1
echo Odd Parity
goto exit
:rsp0 No Parity
goto exit

:exit


