       IDENTIFICATION DIVISION.
       PROGRAM-ID.  ASMTEST.
       DATE-WRITTEN.  Apr-20-1989.
      *
      * This program tests the MS-DOS assembly language interface
      *
      * To compile this program, type "ccbl asmtest.cbl"
      * To assemble the assembly language library, type "masm asmtest;"
      * To link the assembly language library, type "link asmtest;"
      * To run the program, type "runcbl -a asmtest"
      *
       DATA DIVISION.
       WORKING-STORAGE SECTION.

       77  DOS-MAJOR-VERSION-NO                PIC 9(4) COMP-1.
       77  DOS-MINOR-VERSION-NO                PIC 9(4) COMP-1.
       77  CURRENT-DIRECTORY                   PIC X(64).

       PROCEDURE DIVISION.
       MAIN-LOGIC.
           DISPLAY "This program tests the ACUCOBOL-85 assembly ",
                   "language interface".
           DISPLAY "It should print the version number of MS-DOS ",
                   "along with the current directory."
           DISPLAY SPACE.

           CALL "DOS-VERSION" USING DOS-MAJOR-VERSION-NO,
                                    DOS-MINOR-VERSION-NO.
           DISPLAY "MS-DOS Version = ", 
                   DOS-MAJOR-VERSION-NO, CONVERT, LEFT, "."
                   DOS-MINOR-VERSION-NO, CONVERT, LEFT.

           CALL "GET-CURRENT-DIRECTORY" USING CURRENT-DIRECTORY.
           INSPECT CURRENT-DIRECTORY REPLACING ALL LOW-VALUES BY SPACES.
           DISPLAY "Current directory = \", CURRENT-DIRECTORY, LEFT.

           STOP RUN.

               
