*****************************************************************************
*
*               D S C _ G R P
*
*****************************************************************************

function DSC_GRP

parameters txt

res=txt

if at("<",txt)<=0
   res=trim(txt)
else
   res=substr(txt,at("<",txt)+1,at(">",txt)-at("<",txt)-1)+" "+;
       substr(txt,1,at("<",txt)-1)
endif

res=res+space(len(txt)-len(res))

return res

*****************************************************************************
*
*               G _ K E Y
*
*****************************************************************************

procedure G_KEY

parameters v_fin,v_x,vv_xx

private ThC,Timed

v_x=0
ThC=SetColor(CRIEN)
If Type("vv_xx")<>"L" .and. (.not. IsHour)
   @23,65 to 23,79
endif

Timed=60*val(substr(time(),4,2))+val(right(time(),2))

do while .not. chr(v_x) $ v_fin

   v_x=inkey()

   if 60*val(substr(time(),4,2))+val(right(time(),2))-Timed>120
      do PAUSECR with .T.
      Timed=60*val(substr(time(),4,2))+val(right(time(),2))
   endif

   do case
      case v_x=28
           do HELP with "G_KEY",0,"__"
      case v_x=-33
           do MOUSE with "G_KEY",v_fin+chr(255)
      case v_x=-1
           do F2 with "G_KEY"
      case v_x=-3
           do F4
      case v_x=-8
           do F9
      case v_x=-9
           do F10
      case v_x=-11
           do SHF2 with "G_KEY"
      case v_x=-18
           do SHF9
      case v_x=-19
           do SHF10
      case v_x=-23
           do CTRLF4
      case v_x=-28
           do CTRLF9
      case v_x=-29
           do CTRLF10
      case v_x=-39
           do ALTF10
      case v_x=-38
           do ALTF9
   endcase
   if v_x<>0
      Timed=60*val(substr(time(),4,2))+val(right(time(),2))
   endif
   v_x=iif(v_x>=0,v_x,0)
   if IsHour
      @23,65 say "["+time()+"]"
   endif

enddo

Set Color To &ThC

return

*****************************************************************************
*
*                S E T S W P
*
*****************************************************************************

procedure SETSWP

if Colored
   Set Color To N/BG
else
   Set Color To N/W+
endif

return

*****************************************************************************
*
*                B A C E R R
*
*****************************************************************************

Procedure BACERR

Parameters mess,l

Private xscr

MyTone(499,1)
MyTone(300,1)

BACERR=max(len(trim(mess))+3,36)/2
if Colored
   Set Color To W/R
else
   Set Color to N/W*
endif

xscr=SaveScreen(l,40-BACERR,l+3,40+BACERR)

@l,40-BACERR clear to l+3,40+BACERR
@l+1,42-BACERR say trim(mess)
@l+2,42-BACERR say "Appuyez sur la barre d'espace ..."
@l,40-BACERR to l+3,40+BACERR

do G_KEY with " "+chr(27),0

RestScreen(l,40-BACERR,l+3,40+BACERR,xscr)

return

*****************************************************************************
*
*                B A C F I N
*
*****************************************************************************

Procedure BACFIN

Parameter ms,x

do BACERR with ms,x

set color to
clear
set cursor on
cancel

*****************************************************************************
*
*                B A C A F F
*
*****************************************************************************

Procedure BACAFF

Parameters mess,l

Private xscr

MyTone (1500,1)
MyTone (1300,1)

BACERR=max(len(trim(mess))+3,36)/2
Set Color To &NPSGP

xscr=SaveScreen(l,40-BACERR,l+3,40+BACERR)

@l,40-BACERR clear to l+3,40+BACERR
@l+1,42-BACERR say trim(mess)
@l+2,42-BACERR say "Appuyez sur la barre d'espace ..."
@l,40-BACERR to l+3,40+BACERR

do G_KEY with " "+chr(27),0

RestScreen(l,40-BACERR,l+3,40+BACERR,xscr)

return

*****************************************************************************
*
*                B A C O N
*
*****************************************************************************

Procedure BACON

Parameters mess,l,ron

Private xscr

MyTone(1500,1)
MyTone(1300,1)

RONM=iif(ron,"O","N")
cBACON=max(len(trim(mess))+3,20)/2
Set Color To &BSBGP

xscr=SaveScreen(l,40-cBACON,l+3,40+cBACON)

@l,40-cBACON clear to l+3,40+cBACON
@l+1,42-cBACON say trim(mess)
Set Color To &RPSBGP
@l,40-cBACON to l+3,40+cBACON

do while .T.
   srt="oOnN "+chr(9)+chr(271)
   no=iif(ron,1,2)
   do MN999999 with l+2,32,no,RONM,srt
   if srt $ " "+chr(9)+chr(271)
      ron= .not. ron
      loop
   endif
   if srt $ "nN"
      ron=.F.
   else
      if srt $ "oO" .or. (no=1 .and. srt<>chr(27))
         ron=.T.
      else
         ron=.F.
      endif
   endif
   exit
enddo

RestScreen(l,40-cBACON,l+3,40+cBACON,xscr)

Set Color To &BSBGP

return

*****************************************************************************
*
*                B A C P A T
*
*****************************************************************************

Procedure BACPAT

Parameters mess,l

BACON=max(len(trim(mess))+3,29)/2
Set Color To &BSBGP
@l,40-BACON clear to l+3,40+BACON
@l+1,42-BACON say trim(mess)
@l+2,42-BACON say "Veuillez patienter, S.V.P."
Set Color To &RPSBGP
@l,40-BACON to l+3,40+BACON

Set Color To &BSBGP

return

*****************************************************************************
*
*                 S A V S C R
*
*****************************************************************************

Procedure SAVSCR

Private xscr

xscr="XSCR"+str(CurScr,1)
CurScr=CurScr+1
SAVE SCREEN TO &xscr

return

*****************************************************************************
*
*                 R S T S C R
*
*****************************************************************************

Procedure RSTSCR

Private xscr

CurScr=CurScr-1
xscr="XSCR"+str(CurScr,1)
RESTORE SCREEN FROM &xscr

return

*****************************************************************************
*
*                 B A C R L I S T
*
*****************************************************************************

Procedure BACRLIST

Parameters l1,l2,c,l,fin,cle

do while .T.

   Set Color To &NSBGP
   @l,c+2 say ""
   do G_KEY with chr(27)+chr(1)+chr(6)+chr(13)+chr(5)+chr(24)+;
                 chr(18)+chr(3)+fin,cle
   Set Color To &BSBGP
   @l,c+1 say "   "

   do case

      case cle=3            && [PgDn]
           do while l<l2 .and. .not. eof()
              skip
              l=l+1
           enddo
           if eof()
              go bottom
           endif
           exit

      case cle=18           && [PgUp]
           do while l>l1-(l2-l1) .and. .not. bof()
              l=l-1
              skip -1
           enddo
           if bof()
              go top
           endif
           exit

      case cle=6            && [End]
           go bottom
           exit

      case cle=1            && [Home]
           go top
           exit

      case cle=24 .and. .not. eof()    && [Curs. Bas]
           l=l+1
           skip
           if eof()
              go bottom
              exit
           endif
           if l>=l2
              exit
           endif

      case cle=5 .and. .not. bof()     && [Curs. Haut]
           l=l-1
           skip -1
           if bof()
              go top
              exit
           endif
           if l<=l1
              exit
           endif

      otherwise
           exit

      endcase

enddo

set color to &CRIEN

return

*****************************************************************************
*
*                 B A C D L I S 1
*
*****************************************************************************

Procedure BACDLIS1

Parameters l1,c1,l2,c2,v_titre

   Set Color To &BSBGP
   @l1,c1 clear to l2,c2
   @l1,c1 to l2,c2
   Set Color To &BGPSB
   @l1+1,c1+1 say substr(v_titre+space(c2-c1),1,c2-c1-1)
   @l1+1,c2,l2-1,c2 BOX ""

   if eof()
      go bottom
   endif
   Set Color To &BGSRP
   if .not. bof()
      skip -1
   endif
   if bof()
      go top
   else
      @l1+1,c2 say chr(30)
      skip
   endif
   enreg=recno()

   Set Color To &BSBGP

return

*****************************************************************************
*
*                 B A C D L I S 2
*
*****************************************************************************

Procedure BACDLIS2

Parameters l1,c1,l2,c2,enreg

   Set Color To &BGSRP
   if .not. eof()
      @l2-1,c2 say chr(31)
   endif
   go enreg

   set color to &CRIEN

return

Function MyTone

Parameters a,b

if IsToned
   Tone (a,b)
endif

return ""

*****************************************************************************
*
*                 B A C I M P
*
*****************************************************************************

Procedure BACIMP

Parameters fichier,ou,xit

Private imp

MyTone(1500,1)
MyTone(1300,1)
xit=.F.
limp=1
do SAVSCR
Set Color To &RPSBGP
@ou,25 clear to ou+4,64
@ou,25 to ou+4,64
Set Color To &BSBGP
@ou+1,27 say "Sortie sur  IMPRIMANTE  "+Str (MaxLigImp,3)+"  Nb de"
@ou+2,27 say "       sur  ECRAN            lignes."
@ou+3,27 say "ou dans le  FICHIER     "+fichier

do while .T.
   Set Color To &BSBGP
   @ou+1,38 say "(Imprimante)"
   @ou+2,38 say "(Ecran     )"
   @ou+3,38 say "(Fichier   )"
   @ou+1,51 say Str (MaxLigImp,3)
   @ou+3,51 say fichier
   Set Color To &GRPSBGP
   @ou+1,39 say "I"
   @ou+2,39 say "E"
   @ou+3,39 say "F"
   Set Color To &BONCLR

   do case
      case limp=1
           @ou+1,38 say " IMPRIMANTE "

      case limp=2
           @ou+2,38 say " ECRAN      "

      case limp=3
           @ou+3,38 say " FICHIER    "

   endcase

   a=0
   do G_KEY with "e"+"E"+"i"+"I"+"f"+"F"+ ;
                 chr(13)+chr(27)+chr(5)+chr(24),a
   Set Color To &BSBGP
   b=upper(chr(a))

   do case
      case b="F"
           keyboard chr(13)
           limp=3
           loop
      case b="I"
           keyboard chr(13)
           limp=1
           loop
      case b="E"
           keyboard chr(13)
           limp=2
           loop
   endcase

   do case

      case (a=13 .and. limp=1)
           limp=1
           Set Color To &BONCLR
           @ou+1,38 say " IMPRIMANTE "
           Set Color To &CRIEN
           @ou+1,51 get MaxLigImp picture "999"
           do_read()
           if MaxLigImp<15 .and. MaxLigImp<>0
              do BACERR with ;
                 "Le nombre de lignes doit tre suprieur  15",ou+2
              Set Color To &BSBGP
              loop
           endif
           Set Color To &BSBGP
           if mod(readkey(),128)=12
              loop
           else
              fichier="PRN:"
              exit
           endif

      case (a=13 .and. limp=2)
           limp=2
           fichier="CON:"
           exit

      case (a=13 .and. limp=3)
           Set Color To &BONCLR
           @ou+3,38 say " FICHIER    "
           Set Color To &CRIEN
           @ou+1,51 get MaxLigImp picture "999"
           @ou+3,51 get fichier   picture "@K !!!!!!!!!!!!"
           do_read()
           if MaxLigImp<15 .and. MaxLigImp<>0
              do BACERR with ;
                 "Le nombre de lignes doit tre suprieur  15",ou+2
              Set Color To &BSBGP
              loop
           endif
           Set Color To &BSBGP
           if mod(readkey(),128)=12
              loop
           else
              exit
           endif

      case a=27
           xit=.T.
           exit

      case a=24
           limp=mod(limp,3)+1

      case a=5
           limp=iif(limp<=1,3,limp-1)

   endcase

enddo

do RSTSCR

return

*****************************************************************************
*
*                 B A C I S P
*
*****************************************************************************

Procedure BACISP

Parameters lg,xit

c=0
do while .not. isprinter() .and. c<3
   do BACERR with ;
      "L'imprimante n'est pas connecte ("+str(3-c,1)+ ;
      "), vrifiez la touche SELECT",lg
   c=c+1
   if lastkey()=27
      exit
   endif
enddo
xit=.not. isprinter()

return

*****************************************************************************
*
*                 D O _ R E A D
*
*****************************************************************************

Function DO_READ

Private ThC

ThC=SetColor(CRIEN)
if IsHour
   @23,65 say "["+time()+"]"
else
   @23,65 to 23,79
endif
MyTone(1200,1)
SetColor(ThC)

set cursor on
read
set cursor off

SetColor(CRIEN)
if IsHour
   @23,65 say "["+time()+"]"
else
   @23,65 to 23,79
endif
SetColor(ThC)

return ""

*****************************************************************************
*
*                 A G R F R M
*
*****************************************************************************

Procedure AGRFRM

Parameters x1,y1,x2,y2,x1b,y1b,x2b,y2b

Private xp1,yp1,xp2,yp2,xpas1,ypas1,xpas2,ypas2,maxpas

xp1=x1
yp1=y1
xp2=x2
yp2=y2

xpas1=x1b-x1
ypas1=y1b-y1
xpas2=x2b-x2
ypas2=y2b-y2
xpas1=xpas1/5
xpas2=xpas2/5
ypas1=ypas1/5
ypas2=ypas2/5

do while round(xp1,0)<>x1b .or. round(yp1,0)<>y1b .or. round(xp2,0)<>x2b ;
         .or. round(yp2,0)<>y2b
   xp1=xp1+iif(round(xp1,0)=x1b,0,xpas1)
   yp1=yp1+iif(round(yp1,0)=y1b,0,ypas1)
   xp2=xp2+iif(round(xp2,0)=x2b,0,xpas2)
   yp2=yp2+iif(round(yp2,0)=y2b,0,ypas2)
   @round(xp1,0),round(yp1,0) to round(xp2,0),round(yp2,0) double
enddo

return

*****************************************************************************
*
*                 c d o w f
*
*****************************************************************************

Function cdowf

Parameter d

do case
   case dow(d)=1
        return "Dimanche"
   case dow(d)=2
        return "Lundi"
   case dow(d)=3
        return "Mardi"
   case dow(d)=4
        return "Mercredi"
   case dow(d)=5
        return "Jeudi"
   case dow(d)=6
        return "Vendredi"
   case dow(d)=7
        return "Samedi"
endcase

return "?????"

*****************************************************************************
*
*                 c m o n t h f
*
*****************************************************************************

Function cmonthf

Parameter d

do case
   case month(d)=1
        return "Janvier"
   case month(d)=2
        return "Fvrier"
   case month(d)=3
        return "Mars"
   case month(d)=4
        return "Avril"
   case month(d)=5
        return "Mai"
   case month(d)=6
        return "Juin"
   case month(d)=7
        return "Juillet"
   case month(d)=8
        return "Aout"
   case month(d)=9
        return "Septembre"
   case month(d)=10
        return "Octobre"
   case month(d)=11
        return "Novembre"
   case month(d)=12
        return "Dcembre"
endcase

return "?????"

*****************************************************************************
*
*                 C O L O R E
*
*****************************************************************************

Procedure COLORE

Parameter c
if c
   RPSBGP ="R+/BG+"
   RPSBGPT="R+/BG+"
   BSBGP  ="B/BG+"
   GRPSBGP="GR+/BG+"
   BONCLR ="GR+/B"
   GRPSB  ="GR+/B"
   BGPSB  ="BG+/B"
   BSRP   ="B/R+"
   BGSRP  ="BG/R+"
   RP     ="R+"
   NSBGP  ="N/BG+"
   CRIEN  ="W"
   CRIENP ="W+"
   NPSGP  ="N+/G+"
   BSW    ="B/W"
else
   RPSBGP ="W/N,NU"
   RPSBGPT="N/WU+,NU"
   BSBGP  ="W/N,NU"
   GRPSBGP="U,NU"
   GRPSB  ="W+/N,NU"
   BGPSB  ="N/W,NU"
   BSRP   ="N/W,NU"
   BGSRP  ="N/W,NU"
   RP     ="NU+/W,NU"
   NSBGP  ="W*,NU"
   CRIEN  ="W/N,NU"
   CRIENP ="W+/N,NU"
   BONCLR ="N/W,NU"
   NPSGP  ="N/W+,NU"
   BSW    ="N/W,NU"
   CRIEN  ="W,NU"
   CRIENP ="W+,NU"
endif

return

*****************************************************************************
*
*                 d i r e c t
*
*****************************************************************************

Function direct

Parameter TheDir

Private TD

TD=TheDir
if "/" $ TD
   TD=left(TD,at("/",TD)-1)
endif

if right(TD,1)<>"\"
   TD=TD+"\"
endif

return TD
