*****************************************************************************
*
*            A L T F 9
*
*****************************************************************************

Procedure ALTF9

   Colored=.not. Colored
   do COLORE with Colored

return

*****************************************************************************
*
*            C T R L F 1 0
*
*****************************************************************************

Procedure CTRLF10

   keyboard replicate(chr(27),CurScr+1)+"N"+chr(23)+" "
   IsToned=.F.

return

*****************************************************************************
*
*            S H F 1 0
*
*****************************************************************************

Procedure SHF10

   keyboard replicate(chr(27),CurScr+1)+"N"
   IsToned=.F.

return

*****************************************************************************
*
*            F 1 0
*
*****************************************************************************

Procedure F10

   keyboard chr(27)

return

*****************************************************************************
*
*            F 9
*
*****************************************************************************

Procedure F9

Private Indic,ThC,x,colf2,rowf2

   colf2=col()
   rowf2=row()

   IsToned=.not. IsToned

   Indic=SaveScreen(23,60,23,64)
   ThC=SetColor(CRIEN)
   @23,60 say "["+iif(IsToned,"Son","   ")+"]"
   SetColor(ThC)
   if inkey(1)=13
      x=0
      do while x=0
         x=inkey()
         if x=28
            keyboard chr(0)+chr(28)
         endif
      enddo
   endif
   RestScreen(23,60,23,64,Indic)
   @rowf2,colf2 say ""

return

*****************************************************************************
*
*            C T R L F 9
*
*****************************************************************************

Procedure CTRLF9

Private ThC,TheMess,x,colf2,rowf2

   colf2=col()
   rowf2=row()
   ThC=SetColor(CRIEN)
   TheMess=SaveScreen(23,20,23,79)
   @23,20 say "["+cdowf(date())+", "+ltrim(str(day(date())))+ ;
              " "+cmonthf(date())+" "+str(year(date()),4)+" "+ ;
              time()+"]"
   if inkey(2)=13
      X=0
      do while x=0
         x=inkey()
         if x=28
            keyboard chr(0)+chr(28)
         endif
      enddo
   endif
   RestScreen(23,20,23,79,theMess)
   SetColor(ThC)
   @rowf2,colf2 say ""

return

*****************************************************************************
*
*            S H F 9
*
*****************************************************************************

Procedure SHF9

Private ThC,colf2,rowf2

   rowf2=row()
   colf2=col()
   ThC=SetColor(CRIEN)
   IsHour=.not. IsHour
   if IsHour
      @23,65 say "["+time()+"]"
   else
      @23,65 to 23,79
   endif
   SetColor(ThC)
   @rowf2,colf2 say ""

return

*****************************************************************************
*
*            F 2
*
*****************************************************************************

Procedure F2

Parameter a

   if .not. IsPrinter()
      do SHF2 with a
   else
      set print on
      set console off
      do PRTSCR
      set console on
      set print off
   endif

   If a=="G_KEY"
      Set Cursor Off
   endif

return

*****************************************************************************
*
*            S H F 2
*
*****************************************************************************

Procedure SHF2

Parameter a

Private ScrFile,colf2,rowf2

   colf2=col()
   rowf2=row()
   do while file("\SCREEN."+str0(CurPtSc,3))
      CurPtSc=CurPtSc+1
      if CurPtSc>999
         ScrFile=HelpKey
         HelpKey="ECRAN"
         do BACERR with "Copie d'cran impossible.",11
         HelpKey=ScrFile
         @rowf2,colf2 say ""
         return
      endif
   enddo

   ScrFile="\SCREEN."+str0(CurPtSc,3)
   Set Alternate To &ScrFile
   Set Alternate On
   Set Console Off
   do PRTSCR
   Set Alternate Off
   Set Console On
   Close Alternate

   If a=="G_KEY"
      Set Cursor Off
   endif

return

*****************************************************************************
*
*            P R T S C R
*
*****************************************************************************

Procedure PRTSCR

Private lg,cl,cr,lcr,colf2,rowf2

Set Cursor On

colf2=col()
rowf2=row()
For lg=0 to 24
    lcr=""
    For cl=0 to 79
        @lg,cl say ""
        cr=Left(SaveScreen(lg,cl,lg,cl+1),1)
        lcr=lcr+iif(cr>=" ",cr,".")
    Next
    ? lcr
Next
@ rowf2,colf2 say ""

return

*****************************************************************************
*
*            A L T F 1 0
*
*****************************************************************************

Procedure ALTF10

Private TheC,TheF,TheAF,ctc,cr,colf2,rowf2

If HelpKey<>"MENU"
   return
endif

TheC=SetColor(NPSGP)
colf2=col()
rowf2=row()
cr=HelpKey
HelpKey="ECRAN"

do SAVSCR

@0,73,6,79 box "𸳾Գ"
SetColor(BSBGP)
@1,74 clear to 5,78
TheF=asc(left(FondP,1))
SetColor(RPSBGP)
@2,74 to 4,78
SetColor(BSBGP)

do while .T.
 for lf2=1 to 5
     @lf2,75 say ;
      replicate(chr(iif(TheF-3+lf2<0,256-(TheF-3+lf2),mod(TheF-3+lf2,256))),3)
 next
 SetColor(RP)
 @3,75 say replicate(chr(TheF),3)
 SetColor(BSBGP)
 ctc=0
 do G_KEY with chr(27)+chr(13)+chr(5)+chr(24)+chr(18)+chr(3),ctc,.F.
 if ctc=27 .or. ctc=13
    exit
 endif
 TheF=TheF+iif(ctc=5 .or. ctc=18,-1,1)
 TheF=iif(TheF<0,255,iif(TheF>255,0,TheF))
enddo

do RSTSCR

if ctc=13
   FondP=replicate(chr(TheF),9)
endif

HelpKey=cr
set color to &CRIEN
@ 2,0,22,79 Box FondP

SetColor(TheC)
@rowf2,colf2 say ""

return

*****************************************************************************
*
*            s t r 0
*
*****************************************************************************

Function str0

Parameters chaine,long1,long2

Private a,b

if type("long2")<>"N"
   a=str(chaine,long1)
else
   a=str(chaine,long1,long2)
endif

b=""

for i=1 to len(a)
    b=b+iif(substr(a,i,1)=" ","0",substr(a,i,1))
next

return b

*****************************************************************************
*
*            H E L P
*
*****************************************************************************

Procedure HELP

Parameters a,b,c

Private TheColor,TheScreen,x,y,HlpFile,Rdc,Crd,FinHlp,TheMess,TSA, ;
        colf2,rowf2,HK

if HelpKey="NOHELP"
   return
endif

if IsHelp
   keyboard chr(13)+"AIDE"+chr(13)
   return
endif

HK=HelpKey
HelpKey="AIDE"
Colf2=col()
rowf2=row()
Set cursor off
TheMess=SaveScreen(24,0,24,79)
TheScreen=SaveScreen(5,15,20,64)
TheColor=SetColor(GRPSB)
@5,15,20,64 BOX "͸ "
@5,16 say " Aide "
@5,25 say " "+cdowf(date())+", "+ltrim(str(day(date())))+ ;
          " "+cmonthf(date())+" "+str(year(date()),4)+" "
@5,55 say iif(ReadInsert()," Ins ","")

IsHelp=.T.
alphabet="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz"

if file(HelpName+".DBF") .and. file(HelpName+".DBT") ;
   .and. file(HelpName+".NTX") .and. HelpKey<>chr(0)

 SetColor(CRIENP)
 @24,0
 @24,10 say "Utilisez [], [PgUp], [],"+ ;
            " [PgDn], [End], [Home], [Enter] ou [Esc]."
 TSA=Select()
 select 0
 use (HelpName) index (HelpName)

 do while .T.

   set color to &GRPSB
   if bof()
      @20,20 say " Dbut "
   else
      @20,20 to 20,27
   endif
   @20,35 say " Page "+str0(recno(),3)+"/"+str0(reccount(),3)+" "

   set color to &BGPSB
   memoedit(MEMO,6,16,19,63,.F.,.F.)

   x=0
   do G_Key with alphabet+chr(27)+chr(6)+chr(18)+" "+ ;
                 chr(5)+chr(3)+chr(1)+chr(24)+chr(13),x
   set color to &GRPSB
   @20,28 to 20,34

   do case
      case x=27               && [Esc]
           exit

      case x=03 .or. x=24     && [PgDn] ou [Curs bas]
           skip
           if eof()
              go bottom
              @20,28 say " Fin "
           endif

      case x=06               && [End]
           go bottom
           @20,28 say " Fin "

      case x=01               && [Home]
           go top
           skip -1

      case x=18 .or. x=05     && [PgUp] ou [Curs haut]
           skip -1

      case x=13 .or. x=32     && [Enter] ou [Space]
           Topic=A_TOPIC
           @20,36 to 20,54
           @20,35 say " Cl :            "
           x="N/N,"+GRPSB
           set color to &x
           @20,42 get Topic picture "@!"
           set color to &CRIEN
           do_read()
           set color to &GRPSB
           @20,36 to 20,54
           @20,36 say "Page "+str0(recno(),3)+"/"+str0(reccount(),3)
           if mod(readkey(),128)=12
              loop
           endif
           x=recno()
           set exact off
           set order to 1
           seek trim(Topic)
           Topic=found()
           set order to 0
           if .not. Topic
              go x
              do BACERR with "Cl inexistante dans le fichier d'aide.",21
           endif

      case chr(x) $ alphabet
           keyboard chr(13)+chr(25)+chr(x)

   endcase
 enddo
 use
 select (TSA)

endif
if .not. (file(HelpName+".DBF") .and. file(HelpName+".DBT") .and. ;
          file(HelpName+".NTX")) .or. HelpKey=chr(0)
   @11,23 say "Aide non disponible"
   @14,28 say "Tapez [Echap]."
   do G_KEY with chr(27),0
endif

RestScreen(5,15,20,64,TheScreen)
RestScreen(24,0,24,79,TheMess)
SetColor(TheColor)

if a<>"G_KEY"
   set cursor on
endif
IsHelp=.F.
@rowf2,colf2 say ""
HelpKey=HK

Return

*****************************************************************************
*
*            F 4
*
*****************************************************************************

Procedure F4

Private TheC,AL,AC,Hlp,TheOrder

Hlp=HelpKey
TheC=SetColor(CRIEN)
AL=row()
AC=col()
do SAVSCR

clear
HelpKey="NOHELP"
? "Tapez EXIT pour revenir  l'application."
?
set cursor on

do while .T.

   if IsHour
      ? time()
   endif
   accept str(memory(0),3)+" Ko \"+CurDir()+" > " to TheOrder
   set exact on
   if upper(TheOrder)="EXIT"
      exit
   endif
   set exact off
   run &TheOrder

enddo

do RSTSCR
@AL,AC say ""
SetColor(TheC)
Set Cursor Off
HelpKey=Hlp

return

*****************************************************************************
*
*            C T R L F 4
*
*****************************************************************************

Procedure CTRLF4

do PAUSECR with .F.

return

*****************************************************************************
*
*            P A U S E C R
*
*****************************************************************************

Procedure PAUSECR

Parameter Until

Private cf4TheC,AL,AC,xx,yy,dxx,dyy,cf4HK,TheRec,cf4TheSel, ;
        cf4tme,xtyt,xpasa,chenille,xxxyyy,sdx,cf4chg

cf4TheC=SetColor(GRPSB)
cf4HK=HelpKey
AL=row()
AC=col()
do SAVSCR
cf4TheSel=Select()

HelpKey="NOHELP"
@9,24 clear to 11,56
@9,24 to 11,56
@10,26 say "Tapez [Esc] pour revenir ..."
chenille=""
for xx=1 to 20
    chenille=chenille+chr(22)+chr(1)+SaveScreen(22,1,22,1)
next
xx=22
yy=1
dxx=1
dyy=0
xtyt=SaveScreen(xx,yy,xx,yy)
SetColor(CRIEN)
xpasa=""+chr(9)
xpasa=left(xpasa,at(left(FondP,1),xpasa)-1)+ ;
      right(xpasa,len(xpasa)-at(left(FondP,1),xpasa))
cf4tme=60*val(substr(time(),4,2))+val(right(time(),2))
cf4chg=.F.

do while .T.
   cf4chg=(inkey()<>0)
   if cf4chg .and. lastkey()=27
      exit
   endif
   if Until .and. 60*val(substr(time(),4,2))+val(right(time(),2))-cf4tme>120
      exit
   endif
   if IsHour
      @23,65 say "["+time()+"]"
   endif
   RestScreen(asc(left(chenille,1)),asc(substr(chenille,2,1)), ;
              asc(left(chenille,1)),asc(substr(chenille,2,1)), ;
              substr(chenille,3,2))
   xxxyyy=SaveScreen(xx+dxx,yy+dyy,xx+dxx,yy+dyy)
   if left(xxxyyy,1) $ xpasa .or. cf4chg .or. ;
      xx+dxx>24 .or. xx+dxx<0 .or. yy+dyy>79 .or. yy+dyy<0
      dxx=iif(dxx<>0,0,iif(right(time(),1)>"4",1,-1))
      dyy=iif(dxx=0,iif(right(time(),1)>"4",1,-1),0)
      if .not. cf4chg
         loop
      endif
      do case
         case lastkey()=24     && [Haut]
              dxx=1
              dyy=0
         case lastkey()=5      && [Bas]
              dxx=-1
              dyy=0
         case lastkey()=4      && [Droite]
              dxx=0
              dyy=1
         case lastkey()=19     && [Gauche]
              dxx=0
              dyy=-1
      endcase
      loop
   endif
   xtyt=chr(9)+right(xtyt,1)
   RestScreen(xx,yy,xx,yy,xtyt)
   xx=xx+dxx
   yy=yy+dyy
   xtyt=chr(1)+right(xxxyyy,1)
   RestScreen(xx,yy,xx,yy,xtyt)
   chenille=right(chenille,68)+chr(xx)+chr(yy)+xxxyyy
enddo

do RSTSCR
do SAVSCR

if Until
   if 60*val(substr(time(),4,2))+val(right(time(),2))-cf4tme>120
      x=.F.
   else
      x=.T.
   endif
else
   x=.T.
endif

if .not. x
   close all
   set color to
   set cursor on
   Restore Screen From XSCR1
   @ Ligne,0 say ""
   ? "Je suis dgueulasse, je sais ..."
   quit
endif

@AL,AC say ""
SetColor(cf4TheC)
HelpKey=cf4HK

Select (cf4TheSel)
do RSTSCR

return

*****************************************************************************
*
*            M O U S E
*
*****************************************************************************

Procedure MOUSE

Parameter fcall,arg

Private TheScrMOUSE,TheColMOUSE,TheLg,TheCl

if fcall<>"G_KEY"
   arg=chr(27)+chr(32)+chr(18)+chr(3)+chr(6)+chr(1)+chr(13)
endif

TheLg=Row()
TheCl=Col()
TheScrMOUSE=SaveScreen(0,23,7,79)
TheColMOUSE=SetColor("W+")
@ 0,23 clear to 7,79
@ 0,23 to 7,79

SetColor(iif(ISMOUSE(1,arg),"W+","W"))
@   1,25 say " Echappe    [Esc] "
SetColor(iif(ISMOUSE(2,arg),"W+","W"))
@   1,43 say " Espace   [Space] "
SetColor(iif(ISMOUSE(3,arg),"W+","W"))
@   1,61 say " Valider [Return] "
SetColor(iif(ISMOUSE(4,arg),"W+","W"))
@   2,25 say " Page Haut [PgUp] "
SetColor(iif(ISMOUSE(5,arg),"W+","W"))
@   2,43 say " Dbut     [Home] "
SetColor(iif(ISMOUSE(6,arg),"W+","W"))
@   2,61 say " Fin        [End] "
SetColor(iif(ISMOUSE(7,arg),"W+","W"))
@   3,25 say " Page bas  [PgDn] "
SetColor(iif(ISMOUSE(8,arg),"W+","W"))
@   3,43 say " Eff tout [^Home] "
SetColor(iif(ISMOUSE(9,arg),"W+","W"))
@   3,61 say " Un seul   [^End] "
SetColor(iif(ISMOUSE(10,arg),"W+","W"))
@   4,25 say " Mmo         [+] "
SetColor(iif(ISMOUSE(11,arg),"W+","W"))
@   4,43 say " Insrer    [Ins] "
SetColor(iif(ISMOUSE(12,arg),"W+","W"))
@   4,61 say " Supprimer  [Del] "
SetColor(iif(ISMOUSE(13,arg),"W+","W"))
@   5,25 say " Rech. disque [-] "
SetColor(iif(ISMOUSE(14,arg),"W+","W"))
@   5,43 say " Rech. titre  [=] "
SetColor(iif(ISMOUSE(15,arg),"W+","W"))
@   5,61 say " Echanger     [*] "
SetColor(iif(ISMOUSE(16,arg),"W+","W"))
@   6,25 say " Modifier   [Tab] "
SetColor("W+")
@   6,43 say " Aide        [F1] "
@   6,61 say " Annuler       [] "

do while .not. ISMOUSE(LMOUSE,arg)
   LMOUSE=LMOUSE+1
enddo

v_lgmax=16

do while .T.

   do MFMOUSE with arg,.T.
   MOUSEKey=inkey(0)
   do MFMOUSE with arg,.F.

   do case
      case MOUSEKey=5
           LMOUSE=LMOUSE-iif(LMOUSE<=3,0,3)
           do while .not. ISMOUSE(LMOUSE,arg) .and. LMOUSE>4
              LMOUSE=LMOUSE-iif(LMOUSE<=3,0,3)
           enddo
           if .not. ISMOUSE(LMOUSE,arg)
              keyboard chr(19)
           endif

      case MOUSEKey=24
           LMOUSE=LMOUSE+iif(LMOUSE<=15,3,0)
           do while .not. ISMOUSE(LMOUSE,arg) .and. LMOUSE<=15
              LMOUSE=LMOUSE+iif(LMOUSE<=15,3,0)
           enddo
           if .not. ISMOUSE(LMOUSE,arg)
              keyboard chr(4)
           endif

      case MOUSEKey=19
           LMOUSE=iif(LMOUSE=1,18,LMOUSE-1)
           do while .not. ISMOUSE(LMOUSE,arg)
              LMOUSE=iif(LMOUSE=1,18,LMOUSE-1)
           enddo

      case MOUSEKey=4
           LMOUSE=iif(LMOUSE=18,1,LMOUSE+1)
           do while .not. ISMOUSE(LMOUSE,arg)
              LMOUSE=iif(LMOUSE=18,1,LMOUSE+1)
           enddo

      case MOUSEKey=1
           LMOUSE=MOD(LMOUSE-1,3)+1
           if .not. ISMOUSE(LMOUSE,arg)
              Keyboard chr(24)
           endif

      case MOUSEKey=6
           LMOUSE=MOD(LMOUSE-1,3)+16
           if .not. ISMOUSE(LMOUSE,arg)
              Keyboard chr(5)
           endif

      case MOUSEKey=28
           keyboard chr(28)
           exit

      case MOUSEKey=13
           do case
              case LMOUSE=1
                   keyboard chr(27)
              case LMOUSE=2
                   keyboard chr(32)
              case LMOUSE=3
                   keyboard chr(13)
              case LMOUSE=4
                   keyboard chr(18)
              case LMOUSE=5
                   keyboard chr(1)
              case LMOUSE=6
                   keyboard chr(6)
              case LMOUSE=7
                   keyboard chr(3)
              case LMOUSE=8
                   keyboard chr(29)
              case LMOUSE=9
                   keyboard chr(23)
              case LMOUSE=10
                   keyboard "+"
              case LMOUSE=11
                   keyboard chr(22)
              case LMOUSE=12
                   keyboard chr(7)
              case LMOUSE=13
                   keyboard "-"
              case LMOUSE=14
                   keyboard "="
              case LMOUSE=15
                   keyboard "*"
              case LMOUSE=16
                   keyboard chr(9)
              case LMOUSE=17
                   keyboard chr(28)
           endcase
           exit

      case MOUSEKey=27
           exit

      case MOUSEKey=-33
           keyboard chr(27)
           exit

   endcase
enddo

RestScreen(0,23,7,79,TheScrMOUSE)
SetColor(TheColMOUSE)
@ TheLg,TheCl say ""

return

*****************************************************************************
*
*            M F M O U S E
*
*****************************************************************************

Procedure MFMOUSE

parameters aMOUSEx,vMOUSEx

if vMOUSEx
   do SETSWP
else
   SetColor (iif(ISMOUSE(LMOUSE,aMOUSEx),"W+","W"))
endif

do case
   case LMOUSE=1
        @   1,25 say " Echappe    [Esc] "
   case LMOUSE=2
        @   1,43 say " Espace   [Space] "
   case LMOUSE=3
        @   1,61 say " Valider [Return] "
   case LMOUSE=4
        @   2,25 say " Page Haut [PgUp] "
   case LMOUSE=5
        @   2,43 say " Dbut     [Home] "
   case LMOUSE=6
        @   2,61 say " Fin        [End] "
   case LMOUSE=7
        @   3,25 say " Page bas  [PgDn] "
   case LMOUSE=8
        @   3,43 say " Eff tout [^Home] "
   case LMOUSE=9
        @   3,61 say " Un seul   [^End] "
   case LMOUSE=10
        @   4,25 say " Mmo         [+] "
   case LMOUSE=11
        @   4,43 say " Insrer    [Ins] "
   case LMOUSE=12
        @   4,61 say " Supprimer  [Del] "
   case LMOUSE=13
        @   5,25 say " Rech. disque [-] "
   case LMOUSE=14
        @   5,43 say " Rech. titre  [=] "
   case LMOUSE=15
        @   5,61 say " Echanger     [*] "
   case LMOUSE=16
        @   6,25 say " Modifier   [Tab] "
   case LMOUSE=17
        @   6,43 say " Aide        [F1] "
   case LMOUSE=18
        @   6,61 say " Annuler       [] "
endcase

return

*****************************************************************************
*
*            I S M O U S E
*
*****************************************************************************

Function ISMOUSE

Parameters IM1,IM2

do case
   case IM1=1
        Return (chr(27) $ IM2)
   case IM1=2
        Return (chr(32) $ IM2)
   case IM1=3
        Return (chr(13) $ IM2)
   case IM1=4
        Return (chr(18) $ IM2)
   case IM1=1
        Return (chr(1) $ IM2)
   case IM1=6
        Return (chr(6) $ IM2)
   case IM1=7
        Return (chr(3) $ IM2)
   case IM1=8
        Return (chr(29) $ IM2)
   case IM1=9
        Return (chr(23) $ IM2)
   case IM1=10
        Return ("+" $ IM2)
   case IM1=11
        Return (chr(22) $ IM2)
   case IM1=12
        Return (chr(7) $ IM2)
   case IM1=13
        Return ("-" $ IM2)
   case IM1=14
        Return ("=" $ IM2)
   case IM1=15
        Return ("*" $ IM2)
   case IM1=16
        Return (chr(9) $ IM2)
endcase

Return .T.
