Program W;  { Dos in a text Window }

{ Syntax: W /P /Wx,y,x1,y1,cf,cb /Bx,y,x1,y1,cf,cb,DS }

Uses Dos, Crt;

Const Fin   : Boolean = False;
      Pause : Boolean = False;

Type Str12  = String [ 12];
     StrMax = String [255];

Var L : StrMax;
    I : Byte;

{----------------------------------------------------------------------------}

Procedure LireDos (Var S : StrMax);

Var

   Regs       : Registers;
   C          : Char;
   A          : Byte;

Begin

   S := '';

   Repeat

     A := 0;
     C := #000;
     If KeyPressed Then C := ReadKey;
     If C In [#003, #027]
        Then C := #026
        Else Begin
          Regs.AH := $0B;
          Intr ($21,Regs);
          A := Regs.AL;
          Regs.AH := $08;
          If A <> 0 Then Intr ($21,Regs);
          C := Chr (Regs.AL);
             End;

     If (A <> 0) And Not (C In [#010, #013, #026]) Then S := S + C;

   Until C In [#013, #026];

   If C = #026 Then Fin := True;

End;   { LireDos }

{----------------------------------------------------------------------------}

Function Iif (Test : Boolean; Val1, Val2 : Integer) : Integer;

Begin

   If Test Then Iif := Val1 Else Iif := Val2;

End; { Iif }

{----------------------------------------------------------------------------}

Function Replicate (C : Char; X : Byte) : StrMax;

Var S : StrMax;

Begin

   S [0] := Chr (X);

   While X > 0 Do Begin S [X] := C; Dec (X); End;

   Replicate := S;

End; { Replicate }

{----------------------------------------------------------------------------}

Procedure Box (L, U, R, D : Byte; F : Str12);

Var I : Byte;

Begin

   If L = R Then For I := 1 To 9 Do F [I] := F [8];
   If U = D Then For I := 1 To 9 Do F [I] := F [2];
   GotoXY (L, U); Write (F [1]);

   If L < R-1
   Then Begin
      For I := L+1 To R-1 Do Write (F [2]);
      Write (F [3]);
        End; { For If }

   If U < D-1
   Then
      For I := U+1 To D-1 Do
      Begin
         GotoXY (L, I); Write (F [8]);
         If L < R-1
         Then Begin
            Write (Replicate (F [9], R-L-1));
            Write (F [4]);
               End; { For If }
      End; { For If }

   GotoXY (L, D); Write (F [7]);
   If L < R-1
   Then Begin
      For I := L+1 To R-1 Do Write (F [6]);
      Write (F [5]);
        End; { For If }

End; { Box }

{----------------------------------------------------------------------------}

Procedure Help;

Begin

  WriteLn ('Syntax: W /P /Wx,y,x1,y1,cf,cb /Bx,y,x1,y1,cf,cb,DS');

End;

{----------------------------------------------------------------------------}

Procedure SetBox (TheBox : StrMax);

Var Frame : Str12;
    N     : Array [1..6] Of Byte;
    C     : Char;
    I,J,V,
    Cd    : Integer;

Begin

   If TheBox [0] < #2 Then Help;
   If TheBox [1] <> '/' Then Help;
   C := UpCase (TheBox [2]);
   If Not (C In ['B','W','P']) Then Help;

   If C = 'P'
      Then Pause := True
      Else Begin
         Frame := '';
         I := 2;
         TheBox [1] := #027;
         For J := 1 To 6 Do
             If Pos (',', TheBox) > I
                Then Begin
                  Val (Copy (TheBox, I+1, Pos (',', TheBox)-I-1), V, Cd);
                  N [J] := V;
                  I := Pos (',', TheBox);
                  TheBox [I] := #027;
                     End { Then }
                Else Begin
                  V := 0;
                  If I <= Length (TheBox)
                  Then Val (Copy (TheBox, I+1, Length (TheBox)-I), V, Cd);
                  N [J] := V;
                  I := Length (TheBox);
                     End; { Else }
              { End If }
         Case UpCase (TheBox [I+1]) Of
         'D' : Frame := 'ͻȺ ';
         'S' : Frame := 'Ŀ ';
         End; { Case }

         If N[5] > 0 Then TextColor      (N[5]-1);
         If N[6] > 0 Then TextBackGround (N[6]-1);
         If C = 'B'
            Then
            If Frame [0] > #000
               Then
                 Box (Iif (N[1]<N[3],N[1]-1,N[3]+1),
                      Iif (N[2]<N[4],N[2]-1,N[4]+1),
                      Iif (N[1]>N[3],N[1]-1,N[3]+1),
                      Iif (N[2]>N[4],N[2]-1,N[4]+1), Frame);

         Window (Iif (N[1]<N[3],N[1],N[3]),
                 Iif (N[2]<N[4],N[2],N[4]),
                 Iif (N[1]>N[3],N[1],N[3]),
                 Iif (N[2]>N[4],N[2],N[4]));
         ClrScr;
           End; { If C = 'P' }

End; { SetBox }

{----------------------------------------------------------------------------}

Procedure DoPause;
Var C : Char;
Begin
  Repeat Until KeyPressed;
  Repeat
    C := ReadKey;
    If C In [#003, #026, #027] Then Halt;
  Until Not KeyPressed;
  ClrScr;
End; { DoPause }

{----------------------------------------------------------------------------}

Begin

  For I := 1 To ParamCount Do SetBox (ParamStr (I));

  Repeat
    LireDos (L);
    WriteLn (L);
    If (Hi (WindMax)-Hi(WindMin) < WhereY) And Pause Then DoPause;
  Until Fin;

End.
