program DrawHatch;

{$I typedef.sys}                  {inclure le code du systme graphique}
{$I graphix.sys}
{$I kernel.sys}
{$I hatch.hgh}

var i:integer;
   x1,x2,y1,y2,temp:real;

begin
  InitGraphic;                    {initialise le systme et l'cran}

  DefineWorld(1,0,1000,1000,0);   {dfinit un systme propre pour dessiner}
  SelectWorld(1);                 {le slectionne}
  SelectWindow(1);
  DrawBorder;

  for i:=1 to 5 do                {dessine alatoirement des boites avec un
                                   hachurage alatoire}
  begin
    x1:=100+random(800);
    x2:=100+random(800);
    y1:=100+random(800);
    y2:=100+random(800);

    if x1>x2 then                 {permute les x}
     begin
      temp:=x1;
      x1:=x2;
      x2:=temp;
     end;

    if y1>y2 then                 {permute les y}
     begin
      temp:=y1;
      y1:=y2;
      y2:=temp;
     end;

    DrawSquare(x1,y1,x2,y2,false);          {dessine un carr}
    hatch(x1,y1,x2,y2,random(22)-11);       {le hachure}
  end;

  repeat until keypressed;        {attend qu'une touche soit frappe}
  LeaveGraphic;
end.
