
program FindWorld;

{$I typedef.sys}                       {ces fichiers doivent tre }
{$I graphix.sys}                       {inclus dans cet ordre}
{$I kernel.sys}
{$I windows.sys}
{$I findwrld.hgh}
{$I axis.hgh}
{$I polygon.hgh}
{$I spline.hgh}


procedure FindWorldDem;

var x:real;
    dx,dy,i,n,lines,scale:integer;
    X1,Y1,X2,Y2:integer;
    b,a:PlotArray;

begin

  DefineWindow(1,0,0,XMaxGlb,YMaxGlb); {dfinit les fentres comme l'cran tout entier}
  DefineWindow(2,0,0,XMaxGlb,YMaxGlb);
  DefineWorld(1,0,1000,1000,0);        {dfinit un systme propre pour l'cran}

  DefineHeader(2,'UN REPERE ADAPTE');     {fentre o les courbes iront}
  SelectWindow(2);
  SetHeaderOn;

  n:=10;
  for i:=1 to n do
    begin
      a[i,1]:=i-1;
      a[i,2]:=random-0.5;
    end;

  FindWorld(2,a,n,1,1.08);             {ajuste le systme 2  la taille correcte}

  SelectWindow(2);                     {le choisit et trace le cadre}
  DrawBorder;

  dx:=-8;
  dy:=7;
  X1:=3;
  Y1:=5;
  X2:=25;
  Y2:=10;
  lines:=0;
  scale:=0;

  SetLineStyle(0);                     {trace la courbe comme tant une ligne }
  DrawAxis(dx,dy,X1,Y1,X2,Y2,lines,scale,false);
  DrawPolygon(a,1,n,7,2,0);


  SelectWorld(1);                      {choisit une fentre externe}
  SelectWindow(1);

  DrawTextW(730,450,1,^['7@2   Donnees');            {affiche la lgende}
  DrawTextW(730,550,1,'--  Courbe');

end;



begin

InitGraphic;                           {initialiser le systme graphique}

FindWorldDem;                          {dmonstration}

repeat until keypressed;               {attendre qu'une touche soit tape }

LeaveGraphic;                          {quitter le systme graphique }

end.

