
program FlowDemo;

{$I typedef.sys}                             {ces fichiers doivent tre }
{$I graphix.sys}                             {inclus et dans cet ordre}
{$I kernel.sys}
{$I windows.sys}

procedure FlowChartDemo;

var X1,Y1,X2,Y2,i,Count:integer;
    Temp:wrkstring;


procedure DrawArrowHor(X1,Y1,X2,Y2:integer); {tracer une flche horizontale }
                                             {avec la pointe en  [X2,Y2]}
begin
  DrawLine(X1,Y1,X2,Y2);
  if X2>X1 then
   begin
    DrawLine(X2-4,Y2-2,X2,Y2);
    DrawLine(X2-4,Y2+2,X2,Y2);
   end
  else
   begin
    DrawLine(X2+5,Y2-2,X2,Y2);
    DrawLine(X2+5,Y2+2,X2,Y2);
   end;
end;


procedure DrawArrowVer(X1,Y1,X2,Y2:integer); {tracer une flche verticale}
                                             (* avec la pointe en [X2,Y2] *)
begin
  DrawLine(X1,Y1,X2,Y2);
  if Y2>Y1 then
   begin
    DrawLine(X2-2,Y2-3,X2,Y2);
    DrawLine(X2+2,Y2-3,X2,Y2);
   end
  else
   begin
    DrawLine(X2-2,Y2+3,X2,Y2);
    DrawLine(X2+2,Y2+3,X2,Y2);
   end;
end;


procedure Blink(Count,time:integer);     {faire clignoter la fentre en cours}
var i:integer;
begin for i:=1 to Count do
  begin
    Delay(time);
    InvertWindow;
  end;
end;

begin   {FlowChartDemo}
  DefineWindow(1,0,0,79,185);               {definit la fentre 'UN ORGANIGRAMME' }
  DefineWindow(2,12,20,25,40);              {definit la fentre 'DEBUTT'}
  DefineWindow(3,15,55,22,75);              {definit la fentre 'I=1' }
  DefineWindow(4,11,110,26,130);            {definit la fentre 'IF I<=5' }
  DefineWindow(5,47,90,56,110);             {definit la fentre 'I=I+1' }

  ClearScreen;
  SetColorWhite;
  DefineHeader(1,'UN ORGANIGRAMME');
  SetHeaderOn;
  SelectWindow(1);
  DrawBorder;
  SetHeaderOff;

  SelectWindow(2);                          {dessine la fentre 'DEBUT'}
  DrawBorder;
  DrawText(125,27,2,'DEBUT');
  SetWindowModeOff;
  DrawArrowVer(151,40,151,55);              {dessine la ligne d'attache }
  SetWindowModeOn;

  SelectWindow(3);                          {dessine la fentre'I=1'}
  DrawBorder;
  DrawText(136,63,2,'I=1');
  SetWindowModeOff;
  DrawArrowVer(151,75,151,110);             {dessine la ligne les reliant}
  SetWindowModeOn;

  SelectWindow(4);                          {dessine la fentre 'IF I>=5' }
  DrawBorder;
  DrawText(108,118,2,'IF I<=5');
  DrawStraight(215,417,120);                {dessine les lignes d'attache}
  SetWindowModeOff;
  DrawArrowVer(417,120,417,110);
  DrawArrowVer(151,130,151,155);
  SetWindowModeOn;
  SelectWindow(1);
  DrawText(300,110,2,'OUI');
  DrawText(160,137,2,'NON');

  SelectWindow(5);                          {dessine le fentre 'I=I+1' }
  DrawBorder;
  DrawText(390,98,2,'I=I+1');
  SetWindowModeOff;
  DrawLine(417,90,417,80);                  {dessine les lignes d'attache }
  DrawArrowHor(417,80,151,80);

  SetAspect(1.0);                           {trace le cercle  'FIN' }
  DrawCircle(151,165,25);
  SelectWindow(1);
  DrawText(137,163,2,'FIN');
  SetWindowModeOn;
  SetHeaderOn;

  CopyScreen;                               {copier une image de cet cran}
                                            {dans l'cran virtuel en mmoire}
  {ClearEol(25);}
  {gotoxy(27,25);}

  DefineWindow(2,15,21,22,39);              {dfinit la fentre mobile}
  SelectWindow(2);
  SetBackground(0);
  DrawBorder;
  InvertWindow;
  Delay(1000);
  InvertWindow;

  Temp:='123456';                          {initialise le tableau des nombres}
  MoveVer(35,true);             (* dplace la fentre sur l'instruction INIT *)
  DrawText(139,63,2,'I='+Temp[1]);
  Blink(30,50);
  MoveVer(55,true);                        {la dplace dans la boucle}

  for Count:=2 to 6 do                     {traverser la boucle}
    begin
      Delay(500);
      MoveHor(33,true);
      MoveVer(-20,true);
      SetBackground(0);
      DrawBorder;
      DrawText(400,98,2,'I='+Temp[Count]);
      Blink(30,50);
      MoveVer(-20,true);
      MoveHor(-33,true);
      MoveVer(40,true);
    end;

  InvertWindow;
  Delay(1000);
  MoveVer(46,true);                        {aller vers l'instruction 'FIN' }
  Blink(30,50);

  MoveHor(45,true);                        {revenir au dpart}
  MoveVer(-136,true);
  MoveHor(-45,true);
  SetHeaderOn;
end;



begin

InitGraphic;                              {initialiser le systme graphique}

FlowChartDemo;                            {faire la demo}

repeat until keypressed;                  {attendre qu'une touche soit tape }

LeaveGraphic;                             {quitter le systme graphique }

end.

