
program Interpolate;

{$I typedef.sys}                       {ces fichiers doivent tre}
{$I graphix.sys}                       {inclus dans cet ordre}
{$I kernel.sys}
{$I windows.sys}
{$I findwrld.hgh}
{$I axis.hgh}
{$I polygon.hgh}
{$I spline.hgh}


procedure SplineDem;

var x,temp:real;
    dx,dy,i,n,m,lines,scale:integer;
    X1,Y1,X2,Y2:integer;
    b,a:PlotArray;

begin

  DefineWindow(1,0,0,XMaxGlb,YMaxGlb); {les deux fentres couvrent tout l'cran}
  DefineWindow(2,0,0,XMaxGlb,YMaxGlb);
  DefineWorld(1,0,1000,1000,0);        (* dfinir un systme pour l'cran *)

  DefineHeader(2,'Interpolation par Spline'); {fentre contenant les courbes}
  SetHeaderOn;

  n:=12;                               {remplir le tableau des valeurs}
  for i:=1 to n do
    begin
      a[i,1]:=i-1;
      a[i,2]:=random-0.5;
    end;

  m:=50;                            {gnrer une courbe Spline avec 50 points}
  spline(a,n,a[2,1],a[n-1,1],b,m);
  FindWorld(2,b,m,1,1.08);       (* donner la taille correcte au systme 2 *)
  with  world[2] do
   begin
    temp:=y1;
    y1:=y2;
    y2:=temp;
   end;
  SelectWindow(2);                     {selectionner et tracer le cadre}
  DrawBorder;

  dx:=-8;                              {tracer les axes}
  dy:=7;
  X1:=3;
  Y1:=5;
  X2:=25;
  Y2:=10;
  lines:=0;
  scale:=0;

  SetLineStyle(1);    (* tracer la 1re courbe comme une suite de points *)
  DrawAxis(dx,dy,X1,Y1,X2,Y2,lines,scale,false);
  DrawPolygon(a,2,n-1,7,2,0);          {ne pas tracer les points extrmes}

  SetLineStyle(0);                     {tracer la courbe interpole}
  DrawAxis(0,0,X1,Y1,X2,Y2,0,0,false);
  DrawPolygon(b,1,-m,0,0,0);           {ne pas tracer les extrmits}

  SelectWorld(1);                      {choisir la fentre extrieure}
  SelectWindow(1);

  DrawTextW(730,400,1,^['7@2  Donnees');            (* afficher la lgende *)
  DrawTextW(730,500,1,'..  Polygone d''origine');
  DrawTextW(730,600,1,'__  Valeurs interpolees');

end;



begin

InitGraphic;                           {initialiser le systme graphique}

SplineDem;                             {dmonstration}

repeat until keypressed;               {attendre qu'une touche soit tape}

LeaveGraphic;                          {quitter le systme graphique}

end.

