
program MoveWindows;

{$I typedef.sys}             {ces fichiers doivent tre inclus}
{$I graphix.sys}             {et dans cet ordre}
{$I kernel.sys}
{$I windows.sys}

var i: integer;
   Ch: char;

procedure DrawLines;
var i:integer;
begin
  for i:=1 to 20 do DrawLine(i*50,0,1000-i*50,i*50);
end;


begin

InitGraphic;                 {initialiser le systme graphique}


DrawBorder;                  {trace un cadre autour de la zone}
                             {de dessin de la fentre initiale}
                             {par dfaut la fentre initiale}
                             {a les mmes dimensions que l'cran}

DefineWindow(1,trunc(XMaxGlb/10),trunc(YMaxGlb/10),
               trunc(XMaxGlb/2),trunc(YMaxGlb/2));
                             {dfinir une fentre dplace d'un 1/10 }
                             {des bords gauche et suprieur et d'un 1/2}
                             {des bords droit et infrieur }

DefineHeader(1,'VOICI LA FENETRE FIXE'); {en-tte}

DefineWorld(1,0,1000,1000,0); {dfinir un systme de coordonnes propres}

DefineWindow(2,trunc(XMaxGlb/2),trunc(YMaxGlb/2),
               trunc((XMaxGlb*9)/10),trunc((YMaxGlb*9)/10));
                             {dfinir une fentre dplace d'un 1/2 }
                             {des bords gauche et suprieur et d'un 1/2}
                             {des bords droit et infrieur }


DefineHeader(2,'VOICI LA FENETRE A DEPLACER'); {lui donner une en-tte}

DefineWorld(2,0,1000,1000,0); {lui donner un systme de coordonnes propres}

SelectWindow(1);             {selectionner la fentre fixe }
SetHeaderOn;
SelectWorld(1);              {selectionner son systme de coordonnes }
SetBackground(0);            {couleur noire pour le fond }
DrawBorder;                  {dessiner le fentre }
DrawLines;                   {dessiner des lignes  l'intrieur }
CopyScreen;                  {la copier dans l'cran virtuel}

SetBreakOff;                 {pas d'erreur quand on atteind le bord}
SetMessageOff;

SelectWindow(2);             {choisir la fentre mobile }
SetHeaderOn;
SelectWorld(2);              {selectionner son systme de coordonnes }
SetBackground(0);            {fond noir}
DrawBorder;                  {dessiner la fentre}
DrawLines;                   {tracer les lignes}

repeat
  read(Kbd,Ch);              {lire la touche frappe au clavier}
  case ord(Ch) of
      72 : MoveVer(-4,true); {est-ce la flche en haut?}
      75 : MoveHor(-1,true); { gauche ?}
      77 : MoveHor(1,true);  { droite ?}
      80 : MoveVer(4,true);  {en bas ?}
  end;
until Ch=' ';                 { la barre d'espace termine le programme }

LeaveGraphic;                 {quitter le systme graphique }

end.
